;
; < ------------------------ >
;   PureBasic IDE - AddTools 
; < ------------------------ >
;
; This program is free software; you can redistribute it and/or modify it under
; the terms of the GNU General Public License as published by the Free Software
; Foundation; either version 2 of the License, or (at your option) any later
; version. See the License.txt file for more details.
; 
; (c) 2002 Fantaisie Software
;


XIncludeFile "Common.pb"

#WINDOW_AddTools_Width  = 320
#WINDOW_AddTools_Height = 525

Global AddTools_ToolCount.l, AddTools_FirstStart.l
Global AddTools_Arg$, AddTools_TempFileName$

Structure ADDTOOLSENTRIES
  Command.s
  Arguments.s
  WorkingDir.s
  MenuItemName.s
  Shortcut.s
  Flags.l
  ReloadSource.l
  HideEditor.l
EndStructure

NewList AddTools_Entries.ADDTOOLSENTRIES()
NewList AddTools_EntriesTemp.ADDTOOLSENTRIES()

Dim AddTools_Shortcut_Names.s(22)

Global AddTools_TempEntry.ADDTOOLSENTRIES

Declare   AddTools_Open()
Declare   AddTools_Events(EventID)
Declare   AddTools_FillList()
Declare.l AddTools_ItemFromMenuName(Name.s)
Declare.s AddTools_MenuNameFromItem(Item)
Declare   AddTools_AddMenuEntries()
Declare   AddTools_SaveMenuEntries()
Declare   AddTools_MenuClicked(MenuID)
Declare   AddTools_Menu_RunThread(*Value.Byte)
Declare   AddTools_MoveItem(Item,Value)
Declare   AddTools_FillArgumentList(Item)
Declare   AddTools_FillTempLinkedList()
Declare   AddTools_CheckCommandLine()
Declare   AddTools_CheckDoubleName(exception)
Declare   AddTools_CheckDoubleShortCut(exception)
Declare   AddTools_CheckReloadGadgets()

Procedure AddTools_Open()
    
  AddTools_MainWin = OpenWindow(#WINDOW_AddTools, 0, 0, #WINDOW_AddTools_Width, #WINDOW_AddTools_Height, #PB_Window_WindowCentered | #PB_Window_Invisible, Langage(117), WindowID(#WINDOW_Main))
  If AddTools_MainWin
    CreateGadgetList(WindowID())
    
    AddTools_CommandLine  = ""
    AddTools_Arguments    = ""
    AddTools_WorkingDir   = ""
    AddTools_MenuItemName = ""
    AddTools_Shortcut     = ""
    AddTools_CurrentListViewItem = -1

    ResetList( AddTools_Entries() )
    ClearList( AddTools_EntriesTemp() )
    
    If CountList( AddTools_Entries() )
      While NextElement( AddTools_Entries()     )
        AddElement ( AddTools_EntriesTemp() )
        AddTools_EntriesTemp()\Command      = AddTools_Entries()\Command
        AddTools_EntriesTemp()\Arguments    = AddTools_Entries()\Arguments
        AddTools_EntriesTemp()\WorkingDir   = AddTools_Entries()\WorkingDir
        AddTools_EntriesTemp()\MenuItemName = AddTools_Entries()\MenuItemName
        AddTools_EntriesTemp()\Shortcut     = AddTools_Entries()\Shortcut
        AddTools_EntriesTemp()\Flags        = AddTools_Entries()\Flags
        AddTools_EntriesTemp()\ReloadSource = AddTools_Entries()\ReloadSource
        AddTools_EntriesTemp()\HideEditor   = AddTools_Entries()\HideEditor
      Wend
    EndIf
    
    
    AddTools_Shortcut_Names(0) = Langage(140) ; "none"
    For a = 0 To 9 : AddTools_Shortcut_Names(a+1)  = "Alt+" +Str(a) : Next a
    For a = 1 To 12: AddTools_Shortcut_Names(a+10) = "Alt+F"+Str(a) : Next a
    
    TextGadget(#PB_Any,10,10,220,15, Langage(118)): Top = 25 ; "Command Line:"
    StringGadget(#GADGET_AddTools_CommandLine        , 10, Top, 220, 20, "")
    ButtonGadget(#GADGET_AddTools_CommandLineBrowser ,240, Top,  70, 20, Langage(119)): Top + 30  ; "Browse"
    
    TextGadget(#PB_Any,10,Top,300,15, Langage(120)): Top+15 ; "Arguments:    ( %PATH , %FILE , %TEMPFILE )"
    StringGadget(#GADGET_AddTools_Arguments          , 10, Top, 300, 20, ""): Top + 30
    
    TextGadget(#PB_Any,10,Top,100,15, Langage(121)): Top+15 ; "Working Directory:"
    StringGadget(#GADGET_AddTools_WorkingDir         , 10, Top, 220, 20, "")
    ButtonGadget(#GADGET_AddTools_WorkingDirBrowser  ,240, Top,  70, 20, Langage(119)): Top + 30  ; "Browse"

    TextGadget(#PB_Any,10,Top,100,15, Langage(122))           ; "Menu Item Name:"
    TextGadget(#PB_Any,240,Top,70,15, Langage(123)) : Top+15  ; "Shortcut:"
    StringGadget(#GADGET_AddTools_MenuItemName       , 10, Top, 220, 20, "")
    ComboBoxGadget(#GADGET_AddTools_Shortcut         ,240, Top,  70,200): Top + 30
       For a = 0 To 22: AddGadgetItem(#GADGET_AddTools_Shortcut,-1,AddTools_Shortcut_Names(a)) : Next a
       SetGadgetState(#GADGET_AddTools_Shortcut,0)
    
    CheckBoxGadget(#GADGET_AddTools_RunHidden        , 20, Top+20,120,20, Langage(124)) ; "Run Hidden"
    CheckBoxGadget(#GADGET_AddTools_WaitForEnd       ,150, Top+20,156,20, Langage(125)) ; "Wait until tool Quits"
    CheckBoxGadget(#GADGET_AddTools_ReloadSource     , 20, Top+45,280,20, Langage(126)) ; "Reload Source after program has finished"
    OptionGadget  (#GADGET_AddTools_ReloadToNew      , 20, Top+70,120,20, Langage(127)) ; "into new source"  
    OptionGadget  (#GADGET_AddTools_ReloadToOld      , 20, Top+90,120,20, Langage(128)) ; "into current source"
    CheckBoxGadget(#GADGET_AddTools_HideEditor       ,150, Top+70,150,20, Langage(129)) ; "Hide Editor"
      SetGadgetState(#GADGET_AddTools_ReloadToNew,1)
      AddTools_CheckReloadGadgets()
    
    Frame3DGadget(#PB_Any,10,Top,300,120, Langage(130),0): Top+130  ; "Options"
    ButtonGadget(#GADGET_AddTools_Add    , 20,Top, 80, 20, Langage(131)) ; "Add"
    ButtonGadget(#GADGET_AddTools_Insert ,120,Top, 80, 20, Langage(132)) ; "Insert"
    ButtonGadget(#GADGET_AddTools_Replace,220,Top, 80, 20, Langage(133)): Top+30 ;"Replace"
    Frame3DGadget(#PB_Any,0,Top,#WINDOW_AddTools_Width,2,"",2)
    Top+10

    TextGadget(#PB_Any,10,Top,100,15, Langage(134)): Top+15     ; "Menu Entries:"
    ListViewGadget(#GADGET_AddTools_ListView         , 10, Top   ,220,100)
    ButtonGadget(#GADGET_AddTools_ListDelete         ,240, Top   , 70, 20, Langage(135)) ; "Delete"
    ButtonGadget(#GADGET_AddTools_ListUp             ,240, Top+50, 70, 20, Langage(136)) ; "Up"
    ButtonGadget(#GADGET_AddTools_ListDown           ,240, Top+70, 70, 20, Langage(137)) ; "Down"
    Top+116

    ButtonGadget(#GADGET_AddTools_Cancel, #WINDOW_AddTools_Width/2+10, Top, 90, 25, Langage(138)) ; "Cancel"
    ButtonGadget(#GADGET_AddTools_OK    , #WINDOW_AddTools_Width/2-90, Top, 90, 25, Langage(139), #PB_Button_Default) ; "OK"

    AddTools_FillList()
    
    AddKeyboardShortcut(#WINDOW_AddTools, #PB_Shortcut_Return, #GADGET_AddTools_OK)
    AddKeyboardShortcut(#WINDOW_AddTools, #PB_Shortcut_Escape, #GADGET_AddTools_Cancel)

    HideWindow(#WINDOW_AddTools, 0)

  EndIf
EndProcedure

;AddTools_Open()
;While WaitWindowEvent() <> #PB_EventCloseWindow: Wend


Procedure AddTools_Events(EventID)
  DefType.s   pathext
  DefType.l   pathext_length

  If EventID = #PB_Event_Menu     ; Little wrapper to map the shortcut events (identified as menu)
    EventID  = #PB_Event_Gadget   ; to normal gadget events...
    GadgetID = EventMenuID()
  Else
    GadgetID = EventGadgetID()
  EndIf

  Select EventID
    Case #PB_Event_CloseWindow
      Quit = 1
  
    Case #PB_Event_Gadget
      
      Select GadgetID
         Case #GADGET_AddTools_CommandLine
              AddTools_CommandLine = GetGadgetText(#GADGET_AddTools_CommandLine)
         
         Case #GADGET_AddTools_CommandLineBrowser
              ; In the case of Windows, first try to get the valid list of executable extensions
              ; from the environment variables
              CompilerIf #PB_Compiler_OS=#PB_OS_Windows
              pathext_length = GetEnvironmentVariable_("PATHEXT", @pathext, 0)
              If pathext_length = 0
                pathext = "*.exe;*.com;*.bat"
              Else
                pathext = Space(pathext_length-1)
                If GetEnvironmentVariable_("PATHEXT", @pathext, pathext_length)=(pathext_length-1)
                  pathext = "*"+pathext
                  pathext = LCase(ReplaceString(pathext, ";.", ";*."))
                Else
                  pathext = "*.exe;*.com;*.bat"
                EndIf
              EndIf
              CompilerElse
              pathext = "*.exe;*.com;*.bat"
              CompilerEndIf

              A$ = OpenFileRequester("Select File",GetGadgetText(#GADGET_AddTools_CommandLine),"Executable ("+pathext+")|"+pathext+"|All Files|*.*",0)
              If A$ <> ""
                 SetGadgetText(#GADGET_AddTools_CommandLine, A$)
                 AddTools_CommandLine = A$
              EndIf

         Case #GADGET_AddTools_Arguments
              AddTools_Arguments = GetGadgetText(#GADGET_AddTools_Arguments)
              AddTools_CheckReloadGadgets()
              
         Case #GADGET_AddTools_WaitForEnd
              AddTools_CheckReloadGadgets()
         
         Case #GADGET_AddTools_WorkingDir
              AddTools_WorkingDir = GetGadgetText(#GADGET_AddTools_WorkingDir)
         
         Case #GADGET_AddTools_WorkingDirBrowser
              A$ = GetPathPart(GetGadgetText(#GADGET_AddTools_CommandLine))
              A$ = PathRequester("Select Path",A$)
              If A$ <> ""
                 SetGadgetText(#GADGET_AddTools_WorkingDir, A$)
                 AddTools_WorkingDir = A$
              EndIf
         
         Case #GADGET_AddTools_MenuItemName
              AddTools_MenuItemName = GetGadgetText(#GADGET_AddTools_MenuItemName)
         
         Case #GADGET_AddTools_Shortcut
              AddTools_Shortcut = AddTools_Shortcut_Names(GetGadgetState(#GADGET_AddTools_Shortcut))
         
         Case #GADGET_AddTools_Add
              If AddTools_CheckCommandLine() And AddTools_CheckDoubleName(-1) And AddTools_CheckDoubleShortCut(-1)
                 LastElement( AddTools_EntriesTemp() )
                 AddElement ( AddTools_EntriesTemp() )
                 AddTools_FillTempLinkedList()
              EndIf

         Case #GADGET_AddTools_Insert
              If AddTools_CheckCommandLine() And AddTools_CheckDoubleName(-1) And AddTools_CheckDoubleShortCut(-1)
                 If AddTools_CurrentListViewItem = -1
                    LastElement( AddTools_EntriesTemp() )
                    AddElement ( AddTools_EntriesTemp() )
                    AddTools_FillTempLinkedList()
                 Else
                    SelectElement( AddTools_EntriesTemp(), AddTools_CurrentListViewItem )
                    InsertElement( AddTools_EntriesTemp() )
                    AddTools_FillTempLinkedList()
                 EndIf
              EndIf
              
         Case #GADGET_AddTools_Replace
              If AddTools_CurrentListViewItem = -1
                 MessageRequester(Langage(195),"No item selected",#MB_ICONINFORMATION)
              Else
                 If AddTools_CheckCommandLine() And AddTools_CheckDoubleName(AddTools_CurrentListViewItem) And AddTools_CheckDoubleShortCut(AddTools_CurrentListViewItem)
                    SelectElement( AddTools_EntriesTemp(), AddTools_CurrentListViewItem )
                    AddTools_FillTempLinkedList()
                 EndIf
              EndIf
         Case #GADGET_AddTools_ListDelete
              If AddTools_CurrentListViewItem <> -1
                If MessageRequester("Question","Really remove item `"+AddTools_MenuNameFromItem(AddTools_CurrentListViewItem)+" from menu ??",#MB_YESNO|#MB_ICONQUESTION) = #IDYES
                   RemoveGadgetItem(#GADGET_AddTools_ListView,AddTools_CurrentListViewItem)
                   SelectElement( AddTools_EntriesTemp(), AddTools_CurrentListViewItem )
                   DeleteElement( AddTools_EntriesTemp() )
                   AddTools_FillList()
                   AddTools_CurrentListViewItem = -1
                EndIf
              EndIf
         Case #GADGET_AddTools_ListUp
              If AddTools_CurrentListViewItem <> - 1 And AddTools_CurrentListViewItem > 0
                 AddTools_MoveItem(AddTools_CurrentListViewItem,-1)
              EndIf
         Case #GADGET_AddTools_ListDown
              If AddTools_CurrentListViewItem <> - 1 And AddTools_CurrentListViewItem < (CountGadgetItems(#GADGET_AddTools_ListView)-1)
                 AddTools_MoveItem(AddTools_CurrentListViewItem,1)
              EndIf
         
         Case #GADGET_AddTools_ListView
              If EventType() = #PB_EventType_LeftClick
                 AddTools_CurrentListViewItem = GetGadgetState(#GADGET_AddTools_ListView)
              ElseIf EventType() = #PB_EventType_LeftDoubleClick
                 AddTools_CurrentListViewItem = GetGadgetState(#GADGET_AddTools_ListView)
                 AddTools_FillArgumentList(AddTools_CurrentListViewItem)
              EndIf
         
         Case #GADGET_AddTools_OK
              AddTools_SaveMenuEntries()
              CreateIDEMenu(1)
              Quit = 1
         
         Case #GADGET_AddTools_Cancel
              Quit = 1
      
      EndSelect

  EndSelect
  
  If Quit
    ClearList( AddTools_EntriesTemp() )
    CloseWindow(#WINDOW_AddTools)
    UseWindow(#WINDOW_Main)
    AddTools_MainWin = 0
  EndIf
  
EndProcedure


Procedure AddTools_CheckReloadGadgets()
   disable = 1
   A$ = UCase(GetGadgetText(#GADGET_AddTools_Arguments))
   If FindString(A$,"%FILE",1) <> 0  Or  FindString(A$,"%TEMPFILE",1) <> 0
      If GetGadgetState(#GADGET_AddTools_WaitForEnd)
         disable = 0
      EndIf
   EndIf

   DisableGadget(#GADGET_AddTools_ReloadSource,disable)
   DisableGadget(#GADGET_AddTools_ReloadToOld ,disable)
   DisableGadget(#GADGET_AddTools_ReloadToNew ,disable)

   DisableGadget(#GADGET_AddTools_HideEditor  ,1-GetGadgetState(#GADGET_AddTools_WaitForEnd))

EndProcedure


Procedure AddTools_FillList()
  ClearGadgetItemList(#GADGET_AddTools_ListView)
  x = CountList( AddTools_EntriesTemp() )
  If x
     ResetList( AddTools_EntriesTemp() )
     For a = 1 To x
       NextElement( AddTools_EntriesTemp() )
       AddGadgetItem(#GADGET_AddTools_ListView, -1, AddTools_EntriesTemp()\MenuItemName )
     Next a
  EndIf
EndProcedure


Procedure.l AddTools_ItemFromShortCut(string.s)
  For a = 1 To 22
      If AddTools_Shortcut_Names(a) = "Alt+"+string
         ProcedureReturn a
      EndIf
  Next a
ProcedureReturn -1
EndProcedure


Procedure.s AddTools_ShortcutFromItem(Item)
  If Item > 0 And Item < 11
     ProcedureReturn Right(AddTools_Shortcut_Names(Item),1)
  ElseIf Item > 10 And Item < 20
     ProcedureReturn Right(AddTools_Shortcut_Names(Item),2)
  ElseIf Item > 19 And Item < 23
     ProcedureReturn Right(AddTools_Shortcut_Names(Item),3)
  EndIf
  ProcedureReturn ""
EndProcedure


Procedure.l AddTools_ItemFromMenuName(Name.s)
  x = CountList( AddTools_EntriesTemp() )
  If x
     ResetList( AddTools_EntriesTemp() )
     For a = 0 To x - 1
       NextElement( AddTools_EntriesTemp() )
       If AddTools_EntriesTemp()\MenuItemName = Name
          ProcedureReturn a
       EndIf
     Next a
  EndIf
  ProcedureReturn -1
EndProcedure


Procedure.s AddTools_MenuNameFromItem(Item)
  x = CountList( AddTools_EntriesTemp() )
  If x > 0 And Item < x
     SelectElement( AddTools_EntriesTemp(), Item )
     ProcedureReturn AddTools_EntriesTemp()\MenuItemName
  EndIf
  ProcedureReturn ""
EndProcedure


Procedure AddTools_MoveItem(Item,Value)
  count = CountList( AddTools_EntriesTemp() )
  If count > 0 And Item < count
     count - 1
     SelectElement( AddTools_EntriesTemp(), Item )
     AddTools_TempEntry\Command       = AddTools_EntriesTemp()\Command
     AddTools_TempEntry\Arguments     = AddTools_EntriesTemp()\Arguments
     AddTools_TempEntry\WorkingDir    = AddTools_EntriesTemp()\WorkingDir
     AddTools_TempEntry\MenuItemName  = AddTools_EntriesTemp()\MenuItemName
     AddTools_TempEntry\Shortcut      = AddTools_EntriesTemp()\Shortcut
     AddTools_TempEntry\Flags         = AddTools_EntriesTemp()\Flags
     AddTools_TempEntry\ReloadSource  = AddTools_EntriesTemp()\ReloadSource
     AddTools_TempEntry\HideEditor    = AddTools_EntriesTemp()\HideEditor
     
     DeleteElement( AddTools_EntriesTemp() )
     If Value = -1
        Item - 1
        SelectElement( AddTools_EntriesTemp(), Item )
        InsertElement( AddTools_EntriesTemp() )
     ElseIf Value = 1
        If Item = count - 1
           Item + 1
           LastElement( AddTools_EntriesTemp() )
           AddElement( AddTools_EntriesTemp() )
        Else
           Item + 1
           SelectElement( AddTools_EntriesTemp(), Item )
           InsertElement( AddTools_EntriesTemp() )
        EndIf
     EndIf
     AddTools_EntriesTemp()\Command      = AddTools_TempEntry\Command
     AddTools_EntriesTemp()\Arguments    = AddTools_TempEntry\Arguments
     AddTools_EntriesTemp()\WorkingDir   = AddTools_TempEntry\WorkingDir
     AddTools_EntriesTemp()\MenuItemName = AddTools_TempEntry\MenuItemName
     AddTools_EntriesTemp()\Shortcut     = AddTools_TempEntry\Shortcut
     AddTools_EntriesTemp()\Flags        = AddTools_TempEntry\Flags
     AddTools_EntriesTemp()\ReloadSource = AddTools_TempEntry\ReloadSource
     AddTools_EntriesTemp()\HideEditor   = AddTools_TempEntry\HideEditor

     AddTools_FillList()
     SetGadgetState(#GADGET_AddTools_ListView, Item)
     AddTools_CurrentListViewItem = Item

  EndIf
EndProcedure


Procedure AddTools_FillArgumentList(Item)
  count = CountList( AddTools_EntriesTemp() )
  If count > 0 And Item < count
     SelectElement( AddTools_EntriesTemp(), Item )
     SetGadgetText(#GADGET_AddTools_CommandLine  , AddTools_EntriesTemp()\Command      )
     SetGadgetText(#GADGET_AddTools_Arguments    , AddTools_EntriesTemp()\Arguments    )
     SetGadgetText(#GADGET_AddTools_WorkingDir   , AddTools_EntriesTemp()\WorkingDir   )
     SetGadgetText(#GADGET_AddTools_MenuItemName , AddTools_EntriesTemp()\MenuItemName )

     SetGadgetState(#GADGET_AddTools_Shortcut,0)
     If AddTools_EntriesTemp()\Shortcut <> ""
        x = AddTools_ItemFromShortCut(AddTools_EntriesTemp()\Shortcut)
        If x <> -1
           SetGadgetState(#GADGET_AddTools_Shortcut,x)
        EndIf
     EndIf
     
     SetGadgetState(#GADGET_AddTools_WaitForEnd, (AddTools_EntriesTemp()\Flags & 1))
     SetGadgetState(#GADGET_AddTools_RunHidden , (AddTools_EntriesTemp()\Flags & 2))
     
     AddTools_CheckReloadGadgets()
     
     If AddTools_EntriesTemp()\ReloadSource
        SetGadgetState(#GADGET_AddTools_ReloadSource,1)
     Else
        SetGadgetState(#GADGET_AddTools_ReloadSource,0)
     EndIf

     If AddTools_EntriesTemp()\ReloadSource = 2
        SetGadgetState(#GADGET_AddTools_ReloadToNew, 0)
        SetGadgetState(#GADGET_AddTools_ReloadToOld, 1)
     Else
        SetGadgetState(#GADGET_AddTools_ReloadToNew, 1)
        SetGadgetState(#GADGET_AddTools_ReloadToOld, 0)
     EndIf
     
     SetGadgetState(#GADGET_AddTools_HideEditor, AddTools_EntriesTemp()\HideEditor )
     
  EndIf
EndProcedure


Procedure AddTools_FillTempLinkedList()
     AddTools_EntriesTemp()\Command      = GetGadgetText(#GADGET_AddTools_CommandLine)
     AddTools_EntriesTemp()\Arguments    = GetGadgetText(#GADGET_AddTools_Arguments)
     AddTools_EntriesTemp()\WorkingDir   = GetGadgetText(#GADGET_AddTools_WorkingDir)
     AddTools_EntriesTemp()\MenuItemName = GetGadgetText(#GADGET_AddTools_MenuItemName)

     AddTools_EntriesTemp()\Shortcut     = AddTools_ShortcutFromItem(GetGadgetState(#GADGET_AddTools_Shortcut))
     
     AddTools_EntriesTemp()\Flags        = GetGadgetState(#GADGET_AddTools_WaitForEnd)
     AddTools_EntriesTemp()\Flags        | (2 * GetGadgetState(#GADGET_AddTools_RunHidden))

     If GetGadgetState(#GADGET_AddTools_ReloadSource)
        If GetGadgetState(#GADGET_AddTools_ReloadToNew) = 1
           AddTools_EntriesTemp()\ReloadSource = 1
        Else
           AddTools_EntriesTemp()\ReloadSource = 2
        EndIf
     Else
        AddTools_EntriesTemp()\ReloadSource = 0
     EndIf
     
     AddTools_EntriesTemp()\HideEditor = GetGadgetState(#GADGET_AddTools_HideEditor)

     x = ListIndex( AddTools_EntriesTemp() ) - 1
     AddTools_FillList()
     SetGadgetState(#GADGET_AddTools_ListView,x)
     AddTools_CurrentListViewItem = x
EndProcedure


Procedure AddTools_CheckCommandLine()
   If GetGadgetText(#GADGET_AddTools_CommandLine) = ""
      MessageRequester(Langage(32),"You didnt specify a commandline",#MB_ICONERROR)
      ProcedureReturn 0
   EndIf
   ProcedureReturn 1
EndProcedure


Procedure AddTools_CheckDoubleName(exception)
   If GetGadgetText(#GADGET_AddTools_MenuItemName) = ""
      MessageRequester(Langage(32),"You didnt specify a MenuItemName!",#MB_ICONERROR)
      ProcedureReturn 0
   EndIf
   Result = 1
   If CountList( AddTools_EntriesTemp() )
      x  = ListIndex( AddTools_EntriesTemp() ) - 1
      A$ = GetGadgetText(#GADGET_AddTools_MenuItemName)
      ResetList( AddTools_EntriesTemp() )
      For a = 1 To CountList( AddTools_EntriesTemp() )
          NextElement( AddTools_EntriesTemp() )
          If AddTools_EntriesTemp()\MenuItemName = A$ And ( ListIndex( AddTools_EntriesTemp() ) ) <> exception
             Result = 0
          EndIf
      Next a
      If x <> -1
         SelectElement( AddTools_EntriesTemp(), x)
      EndIf
      If Result = 0
         MessageRequester(Langage(32),"MenuItemName "+A$+" already used!",#MB_ICONERROR)
      EndIf
   EndIf
   ProcedureReturn Result
EndProcedure


Procedure AddTools_CheckDoubleShortCut(exception)
  Result = 1
  If CountList( AddTools_EntriesTemp() )
     x  = ListIndex( AddTools_EntriesTemp() ) - 1
     b = GetGadgetState(#GADGET_AddTools_Shortcut)
     If b > 0
        ResetList( AddTools_EntriesTemp() )
        For a = 1 To CountList( AddTools_EntriesTemp() )
            NextElement( AddTools_EntriesTemp() )
            If AddTools_EntriesTemp()\Shortcut = AddTools_ShortcutFromItem(b) And ( ListIndex( AddTools_EntriesTemp() ) ) <> exception
               Result = 0 : c = a-1
               Goto Break_CheckDoubleShortCut
            EndIf
        Next a
     Break_CheckDoubleShortCut:
        If x <> -1
           SelectElement( AddTools_EntriesTemp(), x)
        EndIf
        If Result = 0
           MessageRequester(Langage(32),"ShortCut already used in MenuItem "+AddTools_MenuNameFromItem(c)+"!",#MB_ICONERROR)
        EndIf
     EndIf
  EndIf
  ProcedureReturn Result
EndProcedure


Procedure.l AddTools_GetShortcutKeyFromString( string.s )

   If Len(string) = 1 And Asc(string) => '0' And Asc(string) <= '9'
      ProcedureReturn #PB_Shortcut_Alt | (#PB_Shortcut_0 + (Asc(string) - '0'))  
   ElseIf Len(string) = 2 And Left(string,1) = "F" And Val(Right(string,1)) => 1  And Val(Right(string,1)) <= 9
      ProcedureReturn #PB_Shortcut_Alt | ( #PB_Shortcut_F1 + (Val(Right(string,1)) -1 ) )
   ElseIf Len(string) = 3 And Left(string,1) = "F" And Val(Right(string,2)) => 10 And Val(Right(string,2)) <= 12
      ProcedureReturn #PB_Shortcut_Alt | ( #PB_Shortcut_F1 + (Val(Right(string,2)) -1 ) )
   EndIf
   
ProcedureReturn -1
EndProcedure


Procedure AddTools_SaveTempFile()
  CreateDirectory(FullPath+"Compilers\TempFiles\")
  AddTools_TempFileName$ = FullPath+"Compilers\TempFiles\Temp_"+Hex(Random($FFFF))+".pb"
  If CreateFile(#CREATEFILE_ADDTOOLS_SAVETEMPFILE, AddTools_TempFileName$)
     mylength = SendMessage_(*RichEditGadget, #WM_GETTEXTLENGTH, 0, 0)
     myBuffer = LocalAlloc_(#LMEM_ZEROINIT, mylength+1)
     SendMessage_(*RichEditGadget, #WM_GETTEXT, mylength+1, myBuffer)
     WriteData(myBuffer, myLength+1)
     LocalFree_(myBuffer)
     WriteStringN("")
     WriteStringN("; ExecutableFormat="+FileList()\ExecutableFormat$)

     If FileList()\EnableASM       : WriteStringN("; EnableAsm") : EndIf
     If FileList()\EnableNT4       : WriteStringN("; EnableNT4") : EndIf
     If FileList()\UseIcon         : WriteStringN("; UseIcon="+FileList()\IconName$) : EndIf
     If FileList()\ExecutableName$ : WriteStringN("; Executable="+FileList()\ExecutableName$) : EndIf
     If FileList()\Debugger = 0    : WriteStringN("; DisableDebugger"): EndIf
     WriteString("; EOF")
     CloseFile(#CREATEFILE_ADDTOOLS_SAVETEMPFILE)
     Result = 1
   Else
     Result = 0
   EndIf

   ProcedureReturn Result

EndProcedure


Procedure AddTools_SaveMenuEntries()
   If  CreatePreferences(FullPath+"Tools.prefs")
      PreferenceComment(" PureBasic IDE ToolsMenu Configuration")
      PreferenceComment("")
      PreferenceGroup("ToolsInfo")
        count = CountList( AddTools_EntriesTemp() )
        WritePreferenceLong  ("ToolCount"        , count)
      
        ClearList( AddTools_Entries()     )
        ResetList( AddTools_EntriesTemp() )
      
        If count > 0
        
           For a = 1 To count
           
             NextElement( AddTools_EntriesTemp() )
             AddElement ( AddTools_Entries()     )

             PreferenceComment("")
             PreferenceComment("")
             PreferenceGroup("Tool_"+Str(a))
                
                WritePreferenceString("Command"     , AddTools_EntriesTemp()\Command      )
                WritePreferenceString("Arguments"   , AddTools_EntriesTemp()\Arguments    )
                WritePreferenceString("WorkingDir"  , AddTools_EntriesTemp()\WorkingDir   )
                WritePreferenceString("MenuItemName", AddTools_EntriesTemp()\MenuItemName )
                WritePreferenceString("Shortcut"    , AddTools_EntriesTemp()\Shortcut     )
                WritePreferenceLong  ("Flags"       , AddTools_EntriesTemp()\Flags        )
                WritePreferenceLong  ("ReloadSource", AddTools_EntriesTemp()\ReloadSource )
                WritePreferenceLong  ("HideEditor"  , AddTools_EntriesTemp()\HideEditor   )
                
                AddTools_Entries()\Command      = AddTools_EntriesTemp()\Command     
                AddTools_Entries()\Arguments    = AddTools_EntriesTemp()\Arguments   
                AddTools_Entries()\WorkingDir   = AddTools_EntriesTemp()\WorkingDir  
                AddTools_Entries()\MenuItemName = AddTools_EntriesTemp()\MenuItemName
                AddTools_Entries()\Shortcut     = AddTools_EntriesTemp()\Shortcut    
                AddTools_Entries()\Flags        = AddTools_EntriesTemp()\Flags       
                AddTools_Entries()\ReloadSource = AddTools_EntriesTemp()\ReloadSource
                AddTools_Entries()\HideEditor   = AddTools_EntriesTemp()\HideEditor
           Next a        
        
        EndIf

     ClosePreferences()
   EndIf
EndProcedure


Procedure AddTools_AddMenuEntries()

  ; BUG! CRASHES THE EDITOR - DONT ENABLE !!
  ;
  If AddTools_FirstStart = 1
  ;
  ;  ; Remove old Shortcuts ALT+0 -> ALT+9  and  ALT+F1 -> ALT+F12
    For a = 0 To 9 : RemoveKeyboardShortcut(#WINDOW_Main,#PB_Shortcut_Alt | (#PB_Shortcut_0 + a) ) : Next a
    For a = 0 To 11: RemoveKeyboardShortcut(#WINDOW_Main,#PB_Shortcut_Alt | (#PB_Shortcut_F1+ a) ) : Next a
  ;
  EndIf


  If AddTools_FirstStart = 0

    OpenPreferences(FullPath+"Tools.prefs")
   
      PreferenceGroup("ToolsInfo")
        AddTools_ToolCount      = ReadPreferenceLong  ("ToolCount"        , 0)
      
        If AddTools_ToolCount > 0
        
           For a = 1 To AddTools_ToolCount
           
             AddElement( AddTools_Entries() )
           
             PreferenceGroup("Tool_"+Str(a))
                
                AddTools_Entries()\Command      = ReadPreferenceString("Command"     , "")
                AddTools_Entries()\Arguments    = ReadPreferenceString("Arguments"   , "")
                AddTools_Entries()\WorkingDir   = ReadPreferenceString("WorkingDir"  , "")
                AddTools_Entries()\MenuItemName = ReadPreferenceString("MenuItemName", "")
                AddTools_Entries()\Shortcut     = ReadPreferenceString("Shortcut"    , "")
                AddTools_Entries()\Flags        = ReadPreferenceLong  ("Flags"       , 0 )
                AddTools_Entries()\ReloadSource = ReadPreferenceLong  ("ReloadSource", 0 )
                AddTools_Entries()\HideEditor   = ReadPreferenceLong  ("HideEditor"  , 0 )

           Next a        
        
        EndIf

     ClosePreferences()
     
     AddTools_FirstStart = 1

  EndIf

  Count = CountList(  AddTools_Entries() )
  
  If Count
  
      MenuBar()
    
      ResetList( AddTools_Entries() )
      
      For a = 1 To Count
      
         If NextElement( AddTools_Entries() )
         
            If AddTools_Entries()\Shortcut <> ""
            
              x = AddTools_GetShortcutKeyFromString( AddTools_Entries()\Shortcut )
              If x <> -1
                 MenuItem( #MENU_AddToolsStart+a, AddTools_Entries()\MenuItemName + Chr(9) + "Alt+" + AddTools_Entries()\Shortcut )
                 AddKeyboardShortcut(#WINDOW_Main,x, #MENU_AddToolsStart+a)
              Else
                 MenuItem( #MENU_AddToolsStart+a, AddTools_Entries()\MenuItemName )
              EndIf
              
            Else
              
              MenuItem( #MENU_AddToolsStart+a, AddTools_Entries()\MenuItemName )
              
            EndIf

         EndIf

      Next a 
    
  EndIf

EndProcedure


Procedure AddTools_MenuClicked(MenuID)

   MenuID - #MENU_AddToolsStart
   
   If MenuID <= CountList( AddTools_Entries() )

      SelectElement( AddTools_Entries(), MenuID - 1 )
      
      If AddTools_Entries()\Arguments <> ""
         
         A$ = UCase(AddTools_Entries()\Arguments)
         AddTools_Arg$ = AddTools_Entries()\Arguments
         
         If FindString( A$ , "%FILE", 1)
           If FileList()\FileName$ <> ""
             SaveSourceCode(FileList()\FileName$, 1)
             AddTools_Arg$ = ReplaceString( AddTools_Arg$, "%FILE", FileList()\FileName$, 1 )
             UsedFile = 1
           Else
             AddTools_Arg$ = ReplaceString( AddTools_Arg$, "%FILE", "%TEMPFILE", 1 )
             A$            = ReplaceString( A$           , "%FILE", "%TEMPFILE", 1 )
           EndIf
         EndIf
         If FindString( A$ , "%TEMPFILE", 1)
            If AddTools_SaveTempFile()
               AddTools_Arg$ = ReplaceString( AddTools_Arg$, "%TEMPFILE", AddTools_TempFileName$, 1 )
               UsedTempFile = 1
            Else
               AddTools_Arg$ = ReplaceString( AddTools_Arg$, "%TEMPFILE", "", 1 )
            EndIf
         EndIf
         If FindString( A$ , "%PATH", 1)
            If UsedTempFile
               AddTools_Arg$ = ReplaceString( AddTools_Arg$, "%PATH", GetPathPart( AddTools_TempFileName$ ), 1)
            Else
               AddTools_Arg$ = ReplaceString( AddTools_Arg$, "%PATH", GetPathPart( FileList()\FileName$   ), 1)
            EndIf
         EndIf
      Else
         AddTools_Arg$ = ""
      EndIf

      If AddTools_Entries()\Command <> ""
      
          If AddTools_Entries()\Flags = 1 Or AddTools_Entries()\Flags = 3

            WaitThread.Byte\b = 0
            If AddTools_Entries()\HideEditor
               ShowWindow_(*MainWindow, #SW_HIDE)
            EndIf
            
            EnableWindow_(WindowID(#WINDOW_Main),0)
            CreateThread( @AddTools_Menu_RunThread() , @WaitThread )
            
            While WaitThread\b = 0
              WindowEvent() : Delay( 1 )
            Wend

            EnableWindow_(WindowID(#WINDOW_Main),1)
            ;If AddTools_Entries()\HideEditor
            ShowWindow_(*MainWindow, #SW_SHOW)
            ;EndIf
            ;While WindowEvent(): Wend
            SetWindowPos_(WindowID(#WINDOW_Main),#HWND_TOPMOST  ,0,0,0,0,#SWP_NOMOVE|#SWP_NOSIZE|#SWP_SHOWWINDOW)
            ;While WindowEvent(): Wend
            SetWindowPos_(WindowID(#WINDOW_Main),#HWND_NOTOPMOST,0,0,0,0,#SWP_NOMOVE|#SWP_NOSIZE|#SWP_SHOWWINDOW)
            ;While WindowEvent(): Wend
            UseWindow(#WINDOW_Main)
            ActivateWindow()
            SetFocus_(WindowID(#WINDOW_Main))
            ;While WindowEvent(): Wend
            
            If UsedFile
               If AddTools_Entries()\ReloadSource = 1
                  SendMessage_(*RichEditGadget, #EM_SETMODIFY, #TRUE, 0)
                  LoadSourceCodeReal(FileList()\FileName$, 1)
                  SendMessage_(*RichEditGadget, #EM_SETMODIFY, #TRUE, 0)
               ElseIf AddTools_Entries()\ReloadSource = 2
                  SendMessage_(*RichEditGadget, #WM_SETTEXT, 0, "")
                  SendMessage_(*RichEditGadget, #EM_SETMODIFY, 0, 0)
                  LoadSourceCodeReal(FileList()\FileName$, 1)
                  SendMessage_(*RichEditGadget, #EM_SETMODIFY, #TRUE, 0)
               EndIf
            EndIf
            
            If UsedTempFile
               If AddTools_Entries()\ReloadSource
                  LoadSourceCodeReal(AddTools_TempFileName$, 1)
                  FileList()\FileName$ = ""
                  SetGadgetItemText(#GADGET_FilesPanel,GetGadgetState(#GADGET_FilesPanel),"<New>",0)
                  SendMessage_(*RichEditGadget, #EM_SETMODIFY, #TRUE, 0)
               EndIf
            
               DeleteFile(AddTools_TempFileName$)
            
            EndIf

          Else

             RunProgram( AddTools_Entries()\Command , AddTools_Arg$ , AddTools_Entries()\WorkingDir, AddTools_Entries()\Flags )
          
          EndIf

          ShowWindow_(WindowID(#WINDOW_Main),#SW_SHOW)
         
      EndIf
         
   EndIf

EndProcedure


Procedure AddTools_Menu_RunThread(*WaitThread.Byte)

   RunProgram( AddTools_Entries()\Command , AddTools_Arg$ , AddTools_Entries()\WorkingDir, AddTools_Entries()\Flags )

   *WaitThread\b = 1

EndProcedure 
; ExecutableFormat=Window
; Executable=C:\Programmation\PureBasic\PureBasic2.exe
; EOF