Structure CLSID
  Data1.l       
  Data2.w
  Data3.w
  Data4.b[8]
EndStructure  

Interface IMSHelp20 
  QueryInterface(a.l, b.l)
  AddRef()
  Release()
  GetTypeInfoCount(a.l)
  GetTypeInfo(a.l, b.l, c.l)
  GetIDsOfNames(a.l, b.l, c.l, d.l, e.l)
  Invoke(a.l, b.l, c.l, d.l, e.l, f.l, g.l, h.l)
  Contents()
  Index()
  Search()
  IndexResults()
  SearchResults()
  DisplayTopicFromId(a.l, b.l)
  DisplayTopicFromURL(a.l)
  DisplayTopicFromURLEx(a.l, b.l)
  DisplayTopicFromKeyword(a.l)
  DisplayTopicFromF1Keyword(a.l)
  DisplayTopicFrom_OLD_Help(a.l, b.l)
  SyncContents(a.l)
  CanSyncContents(a.l)
  GetNextTopic(a.l, b.l)
  GetPrevTopic(a.l, b.l)
  FilterUI()
  CanShowFilterUI()
  Close()
  SyncIndex(a.l, b.l)
  SetCollection(a.l, b.l)
  GetCollection(a.l)
  GetFilter(a.l)
  SetFilter(a.l)
  FilterQuery(a.l)
  GetHelpOwner(a.l)
  SetHelpOwner(a.l)
  HxSession(a.l)
  Help(a.l)
  GetObject(a.l, b.l, c.l)
EndInterface

Global PlatformSDKObject.IMSHelp20, PlatformSDKHelpString$



Procedure.l IsPlatformSDKAvaiable()
  IsAvaiable = 0

  If RegCreateKeyEx_(#HKEY_CURRENT_USER, "Software\Microsoft\MSDN\7.0\Help", 0, 0, #REG_OPTION_NON_VOLATILE, #KEY_READ , 0, @NewKey, @KeyInfo) = #ERROR_SUCCESS
    Index = 0
    Repeat
      ValueName$ = Space(260)
      ValueNameSize = 260
      ValueData$ = Space(260)
      ValueDataSize = 260
      
      Result = RegEnumValue_(NewKey, Index, @ValueName$, @ValueNameSize, 0, @ValueType, 0, 0)      
      
      If Result = #ERROR_SUCCESS And ValueType = #REG_SZ
        
        If Left(LCase(ValueName$),18) = "ms-help://ms.psdk." ; current version: ms-help://MS.PSDK.1033
          PlatformSDKHelpString$ = ValueName$
          IsAvaiable = 1
            
          Break
        EndIf
        
      EndIf
        
      Index + 1
    Until Result <> #ERROR_SUCCESS

    RegCloseKey_(NewKey)
  EndIf

  ProcedureReturn IsAvaiable
EndProcedure


Procedure.l DisplayPlatformSDKHelp(Keyword$)  
  Success = 0

  If PlatformSDKObject = 0
  
    If PlatformSDKHelpString$ Or IsPlatformSDKAvaiable()
    
      CoInitialize_(0)
      
      DExplore$ = Space(Len("DExplore.AppObj")*2+2)
      MultiByteToWideChar_(#CP_ACP, 0, "DExplore.AppObj", -1, @DExplore$, Len("DExplore.AppObj")*2+2)
      
      CLSIDFromProgID_(@DExplore$, @CLSID_DExplore.CLSID)
      
      If CoCreateInstance_(@CLSID_Dexplore, 0, 4, ?IID_IMSHelp20, @PlatformSDKObject) = #S_OK
      
        HelpSelection$ = Space(Len(PlatformSDKHelpString$)*2+1)
        MultiByteToWideChar_(#CP_ACP, 0, @PlatformSDKHelpString$, -1, @HelpSelection$, Len(PlatformSDKHelpString$)*2+2)     
        
        BSTR_HelpSelection = SysAllocString_(@HelpSelection$)
        
        NullString_UNICODE$ = " "
        PokeB(@NullString_UNICODE$, 0)
        
        BSTR_NullString = SysAllocString_(@NullString_UNICODE$)
        
        PlatformSDKObject\SetCollection(BSTR_HelpSelection, BSTR_NullString)
      
        SysFreeString_(BSTR_HelpSelection)
        SysFreeString_(BSTR_NullString)                
          
      EndIf
    
    EndIf
    
  EndIf

  If PlatformSDKObject <> 0
  
    Keyword_UNICODE$ = Space(Len(KeyWord$)*2+2)
    MultiByteToWideChar_(#CP_ACP, 0, @Keyword$, -1, @Keyword_UNICODE$, Len(Keyword$)*2+2)    
    
    BSTR_Keyword = SysAllocString_(@Keyword_UNICODE$)                
    
    PlatformSDKObject\Contents()
    If PlatformSDKObject\DisplayTopicFromF1Keyword(BSTR_Keyword) = #S_OK    
         
      PlatformSDKObject\SyncIndex(BSTR_Keyword, 1)
      PlatformSDKObject\Index()
                   
      Success = 1

    EndIf
    
    SysFreeString_(BSTR_Keyword)
  
  EndIf

  ProcedureReturn Success
EndProcedure


Procedure ClosePlatformSDKWindow()
  
  If PlatformSDKObject <> 0
  
    PlatformSDKObject\Release()
    CoUninitialize_()
  
  EndIf
  
EndProcedure


DataSection
  IID_IMSHelp20: ; 4A791148-19E4-11D3-B86B-00C04F79F802
    Data.l $4A791148
    Data.w $19E4, $11D3
    Data.b $B8, $6B, $00, $C0, $4F, $79, $F8, $02      
EndDataSection


; ExecutableFormat=Windows
; CursorPosition=146
; FirstLine=121
; DisableDebugger
; EOF