;
; < --------------------------- >
;   PureBasic IDE - Preferences   
; < --------------------------- >
;
; This program is free software; you can redistribute it and/or modify it under
; the terms of the GNU General Public License as published by the Free Software
; Foundation; either version 2 of the License, or (at your option) any later
; version. See the License.txt file for more details.
; 
; (c) 2002 Fantaisie Software
;

XIncludeFile "Common.pb" 

Procedure UsePreferences()
  AutoReload      = GetGadgetState(#GADGET_Preference_AutoReload)
  AutoSave        = GetGadgetState(#GADGET_Preference_AutoSave)
  MemorizeWindow  = GetGadgetState(#GADGET_Preference_MemorizeWindow)
  EnableColoring  = GetGadgetState(#GADGET_Preference_EnableColoring)
  MemorizeCursor  = GetGadgetState(#GADGET_Preference_MemorizeCursor)
  ShowMainToolbar = GetGadgetState(#GADGET_Preference_ShowToolbar)

  PreviousCurrentLanguage.s = CurrentLanguage
  CurrentLanguage = GetGadgetText(#GADGET_Preference_Language)
  SourceDirectory = GetGadgetText(#GADGET_Preference_Source)

  UseCustomScroll = GetGadgetState(#GADGET_Preference_CustomScroll)
  CustomScrollLines = GetGadgetState(#GADGET_Preference_ScrollLinesUpDown)

  If PreviousCurrentLanguage <> CurrentLanguage ; Langage has been changed... Change it in live !
    Localize()
    CreateIDEMenu(1)
    CreateIDEPopupMenu()
    ChangeStatus(" ")
    UpdateToolTips()
  EndIf

  ShowToolbar(ShowMainToolbar)
  
  If SelectedFontName
    EditorFontName  = SelectedFontName
    EditorFontSize  = SelectedFontSize
  EndIf

  ProcedureBrowserType          = ProcedureBrowserTempType
  ProcedureBrowserSide          = ProcedureBrowserTempSide
  ProcedureBrowserBackColor     = ProcedureBrowserTempBackColor
  ProcedureBrowserFrontColor    = ProcedureBrowserTempFrontColor
  ProcedureBrowserFont          = ProcedureBrowserTempFont
  ProcedureBrowserFontHeight    = ProcedureBrowserTempFontHeight
  ProcedureBrowserGroupMarker   = ProcedureBrowserTempGroupMarker
  
  TabLength                     = TabLengthTemp
  
  Editor_RunOnce                = Editor_RunOnceTemp

  If ProcedureBrowserSort <> ProcedureBrowserTempSort
    ProcedureBrowserSort = ProcedureBrowserTempSort
    OpenProcedureBrowser()
  EndIf

  If ProcedureBrowserType = 1   ; ListView
    HideGadget(#GADGET_ProcedureList,1)
    ShowWindow_(*ProcedureBrowser,  #SW_SHOW)
    If ProcedureBrowserSide    ; Procedure Browser Left
       EditLeftOffset  = ProcedureBrowserWidth
       EditRightOffset = 0
    Else                       ; Procedure Browser Right
       EditRightOffset = ProcedureBrowserWidth
       EditLeftOffset  = 0
    EndIf
  Else
      HideGadget(#GADGET_ProcedureList,0)
      ShowWindow_(*ProcedureBrowser,  #SW_HIDE)
      EditRightOffset = 0
      EditLeftOffset  = 0
  EndIf

  DeleteObject_(ProcedureBrowserBackBrush)
  ProcedureBrowserBackBrush = CreateSolidBrush_(ProcedureBrowserBackColor)

  fontflag = 0
  If FindString(UCase(ProcedureBrowserFontStyle$),"BOLD",1)
    fontflag | #PB_Font_Bold
  EndIf
  If FindString(UCase(ProcedureBrowserFontStyle$),"ITALIC",1)
    fontflag | #PB_Font_Italic
  EndIf
  *ProcedureBrowserFontHandle = LoadFont(#FONT_ProcedureBrowser,ProcedureBrowserFont,ProcedureBrowserFontHeight,fontflag)
  SendMessage_(*ProcedureBrowser,#WM_SETFONT,*ProcedureBrowserFontHandle,0)
  InvalidateRect_(*ProcedureBrowser,0,1)
  ProcedureBrowserMustUpdate = 1
  UpdateProcedureList()

  SendMessage_(*MainWindow, #WM_SIZE,#SIZE_RESTORED,0) ; update size
  
EndProcedure


Procedure CancelPreferences()

  ;BackgroundColor   = TmpColor(0);
  ;BasicKeywordColor = TmpColor(1);
  ;CommentColor      = TmpColor(2);
  ;ConstantColor     = TmpColor(3);
  ;StringColor       = TmpColor(4);
  ;PureKeywordColor  = TmpColor(5);
  ;NormalTextColor   = TmpColor(6);

  WasModify = SendMessage_(*RichEditGadget, #EM_GETMODIFY, 0, 0)

  If (SelectedFontName)
    SetEditorFont(EditorFontName, EditorFontSize)
  EndIf

  If ColorChanged
    UpdateTextHighlightning(EnableColoring, 0, 0)
  EndIf
  
  If WasModify = 0 : SendMessage_(*RichEditGadget, #EM_SETMODIFY, 0, 0) : EndIf
  
EndProcedure


Procedure LoadPreferences()

  OpenPreferences(FullPath+"PureBasic.prefs")
  
    PreferenceGroup("Global")
      AutoReload                  = ReadPreferenceLong  ("AutoReload"        , 0)
      MemorizeWindow              = ReadPreferenceLong  ("MemorizeWindow"    , 0)
      CurrentLanguage             = ReadPreferenceString("CurrentLanguage"   , "English")
      SourceDirectory             = ReadPreferenceString("SourceDirectory"   , "Examples")
      DisplayLineNumbers          = ReadPreferenceLong  ("DisplayLineNumbers", 1)
      EnableColoring              = ReadPreferenceLong  ("EnableColoring"    , 1)
      AutoSave                    = ReadPreferenceLong  ("AutoSave"          , 1)
      IsWindowMaximized           = ReadPreferenceLong  ("IsWindowMaximized" , 0)
      Editor_RunOnce              = ReadPreferenceLong  ("RunOnce"           , 1)
      ShowMainToolbar             = ReadPreferenceLong  ("ShowToolbar"       , 1)
      TabLength                   = ReadPreferenceLong  ("TabLength"         , 2)
      MemorizeCursor              = ReadPreferenceLong  ("MemorizeCursor"    , 0)
      RealTimeSyntaxHighlighting  = ReadPreferenceLong  ("RealTimeSyntaxHighlighting", 0)
      VisualDesigner$             = ReadPreferenceString("VisualDesigner"    , "Visual Designer.exe")
      UseCustomScroll             = ReadPreferenceLong  ("UseCustomScroll"   , 0)
      CustomScrollLines           = ReadPreferenceLong  ("CustomScrollLines" , 3)   ; Default system value from the Platform SDK

    PreferenceGroup("Editor")
      EditorWindowX      = ReadPreferenceLong("WindowX"     , 0)
      EditorWindowY      = ReadPreferenceLong("WindowY"     , 0)
      EditorWindowWidth  = ReadPreferenceLong("WindowWidth" , 600)
      EditorWindowHeight = ReadPreferenceLong("WindowHeight", 420)
      
      ASMKeywordColor     = ReadPreferenceLong("ASMKeywordColor"  ,  $724B92)
      BackgroundColor     = ReadPreferenceLong("BackgroundColor"  ,  $DFFFFF)
      BasicKeywordColor   = ReadPreferenceLong("BasicKeywordColor",  $666600)
      CommentColor        = ReadPreferenceLong("CommentColor"     ,  $AAAA00)
      ConstantColor       = ReadPreferenceLong("ConstantColor"    ,  $724B92)
      LabelColor          = ReadPreferenceLong("LabelColor"       ,  0)
      NormalTextColor     = ReadPreferenceLong("NormalTextColor"  ,  0)
      NumberColor         = ReadPreferenceLong("NumberColor"      ,  0)
      OperatorColor       = ReadPreferenceLong("OperatorColor"    ,  0)
      PointerColor        = ReadPreferenceLong("PointerColor"     ,  0)
      PureKeywordColor    = ReadPreferenceLong("PureKeywordColor" ,  $666600)
      SeparatorColor      = ReadPreferenceLong("SeparatorColor"   ,  0)
      StringColor         = ReadPreferenceLong("StringColor"      ,  $666600)
      StringColor2        = ReadPreferenceLong("StringColor2"     ,  NormalTextColor)
      StructureColor      = ReadPreferenceLong("StructureColor"   ,  0)
      BasicKeywordColor_ProgramFlow = ReadPreferenceLong("BasicKeywordColor_PFlow",BasicKeywordColor)
      LineNumberBackColor = ReadPreferenceLong("LineNumberBackColor",$D7FFFF)
      LineNumberColor     = ReadPreferenceLong("LineNumberColor"    ,$CACACA)

      
      EditorFontName    = ReadPreferenceString("EditorFontName", "Courier")
      EditorFontSize    = ReadPreferenceLong  ("EditorFontSize", 10)
      EditorFontStyle$  = ReadPreferenceString("EditorFontStyle","None")

      EditorFontStyle = 0
      If FindString(UCase(EditorFontStyle$),"BOLD",1)
        EditorFontStyle | #PB_Font_Bold
      EndIf
      If FindString(UCase(EditorFontStyle$),"ITALIC",1)
        EditorFontStyle | #PB_Font_Italic
      EndIf

   PreferenceGroup("StructureViewer")
      StructureViewerX           = ReadPreferenceLong("X"      , 100)
      StructureViewerY           = ReadPreferenceLong("Y"      , 100)
      StructureViewerWidth       = ReadPreferenceLong("Width"  , 330)
      StructureViewerHeight      = ReadPreferenceLong("Height" , 400)
      StructureViewerIncludeType = ReadPreferenceLong("IncType", 0)
   
   PreferenceGroup("ProcedureBrowser")
      ProcedureBrowserType        = ReadPreferenceLong  ("Type"       , 1)
      ProcedureBrowserSide        = ReadPreferenceLong  ("Side"       , 0) ; Side: 0 = Right, 1 = Left
      ProcedureBrowserFont        = ReadPreferenceString("Font"       , EditorFontName)
      ProcedureBrowserFontHeight  = ReadPreferenceLong  ("FontSize"   , EditorFontSize)
      ProcedureBrowserFontStyle$  = ReadPreferenceString("FontStyle"  ,"None")
      ProcedureBrowserBackColor   = ReadPreferenceLong  ("BackColor"  , BackgroundColor)
      ProcedureBrowserFrontColor  = ReadPreferenceLong  ("FrontColor" , NormalTextColor)
      ProcedureBrowserWidth       = ReadPreferenceLong  ("Width"      , 160)
      ProcedureBrowserSort        = ReadPreferenceLong  ("Sort"       , 1)
      If ProcedureBrowserSort = 1
        ProcedureBrowserGroupMarker = 1
      Else
        ProcedureBrowserGroupMarker = ReadPreferenceLong  ("GroupMarker", 1)
      EndIf

      If ProcedureBrowserType = 1
        If ProcedureBrowserSide
          EditLeftOffset  = ProcedureBrowserWidth
        Else
          EditRightOffset = ProcedureBrowserWidth
        EndIf
      EndIf
      
      ; Background Brush for ProcedureBrowser
      ProcedureBrowserBackBrush = CreateSolidBrush_(ProcedureBrowserBackColor)

   PreferenceGroup("PickColorPrefs")
      ; PickColor_StayOnTop       = ReadPreferenceLong  ("StayOnTop" , 1)
      PickColor_CloseAfterDone  = ReadPreferenceLong  ("CloseAfterDone" , 1)

   PreferenceGroup("RecentFiles")
      RecentFilesCount            = ReadPreferenceLong  ("Count", 0)
      If RecentFilesCount
        ClearList(RecentFiles())
        If RecentFilesCount > #RECENTFILES_Maximum : RecentFilesCount = #RECENTFILES_Maximum : EndIf
         
        For k = 1 To RecentFilesCount
          AddElement(RecentFiles())
          RecentFiles() = ReadPreferenceString("RecentFile_"+Str(k),"")
        Next         
      EndIf

   PreferenceGroup("OpenedFiles")
      OpenedFilesCount = ReadPreferenceLong  ("Count", 0)
      If OpenedFilesCount
        For k = 1 To OpenedFilesCount
          AddElement(OpenedFiles())
          OpenedFiles() = ReadPreferenceString("OpenedFile_"+Str(k),"")
        Next          
      EndIf
      
   PreferenceGroup("GrepOutput")
      GrepOutputX           = ReadPreferenceLong("X"      , 100)
      GrepOutputY           = ReadPreferenceLong("Y"      , 200)
      GrepOutputWidth       = ReadPreferenceLong("Width"  , 430)
      GrepOutputHeight      = ReadPreferenceLong("Height" , 300)
      
  ClosePreferences()  
EndProcedure


Procedure SavePreferences()

  If MemorizeWindow

    *MainWindow = UseWindow(#WINDOW_Main)
    If (GetWindowLong_(*MainWindow, #GWL_STYLE) & #WS_MINIMIZE) = 0
      If GetWindowLong_(*MainWindow, #GWL_STYLE) & #WS_MAXIMIZE
        IsWindowMaximized = 1
      Else
        IsWindowMaximized = 0;

        EditorWindowX      = WindowX()
        EditorWindowY      = WindowY()
        EditorWindowWidth  = WindowWidth()
        EditorWindowHeight = WindowHeight()
      EndIf
    EndIf
  EndIf

  If CreatePreferences(FullPath+"PureBasic.prefs")

    PreferenceComment(" PureBasic IDE Preference File")
    
    PreferenceComment("")
    WritePreferenceLong("PreferenceVersion", 1)
    
    PreferenceComment("")
    PreferenceGroup("Global")
      WritePreferenceLong  ("AutoReload"        , AutoReload)
      WritePreferenceLong  ("MemorizeWindow"    , MemorizeWindow)
      WritePreferenceString("CurrentLanguage"   , CurrentLanguage)
      WritePreferenceString("SourceDirectory"   , SourceDirectory)
      WritePreferenceString("CurrentFileName"   , FileList()\FileName$)
      WritePreferenceLong  ("DisplayLineNumbers", DisplayLineNumbers)
      WritePreferenceLong  ("EnableColoring"    , EnableColoring)
      WritePreferenceLong  ("AutoSave"          , AutoSave)
      WritePreferenceLong  ("IsWindowMaximized" , IsWindowMaximized)
      WritePreferenceLong  ("RunOnce"           , Editor_RunOnce)
      WritePreferenceLong  ("ShowToolbar"       , ShowMainToolbar)
      WritePreferenceLong  ("TabLength"         , TabLength)
      WritePreferenceLong  ("MemorizeCursor"    , MemorizeCursor)
      WritePreferenceLong  ("RealTimeSyntaxHighlighting",RealTimeSyntaxHighlighting)
      WritePreferenceString("VisualDesigner"    , VisualDesigner$)
      WritePreferenceLong  ("UseCustomScroll"   , UseCustomScroll)
      WritePreferenceLong  ("CustomScrollLines" , CustomScrollLines)

    PreferenceComment("")
    PreferenceGroup("Editor")
      WritePreferenceLong("WindowX"     , EditorWindowX)
      WritePreferenceLong("WindowY"     , EditorWindowY)
      WritePreferenceLong("WindowWidth" , EditorWindowWidth)
      WritePreferenceLong("WindowHeight", EditorWindowHeight)
      
      PreferenceComment("")
      WritePreferenceLong("ASMKeywordColor"  , ASMKeywordColor)
      WritePreferenceLong("BackgroundColor"  , BackgroundColor)
      WritePreferenceLong("BasicKeywordColor", BasicKeywordColor)
      WritePreferenceLong("BasicKeywordColor_PFlow",BasicKeywordColor_ProgramFlow)
      WritePreferenceLong("CommentColor"     , CommentColor)
      WritePreferenceLong("ConstantColor"    , ConstantColor)
      WritePreferenceLong("LabelColor"       , LabelColor)
      WritePreferenceLong("NormalTextColor"  , NormalTextColor)
      WritePreferenceLong("NumberColor"      , NumberColor)
      WritePreferenceLong("OperatorColor"    , OperatorColor)
      WritePreferenceLong("PointerColor"     , PointerColor)
      WritePreferenceLong("PureKeywordColor" , PureKeywordColor)
      WritePreferenceLong("SeparatorColor"   , SeparatorColor)
      WritePreferenceLong("StringColor"      , StringColor)
      WritePreferenceLong("StringColor2"     , StringColor2)
      WritePreferenceLong("StructureColor"   , StructureColor)
      WritePreferenceLong("LineNumberBackColor",LineNumberBackColor)
      WritePreferenceLong("LineNumberColor"    ,LineNumberColor)


      PreferenceComment("")
      WritePreferenceString("EditorFontName", EditorFontName)
      WritePreferenceLong  ("EditorFontSize", EditorFontSize)
      WritePreferenceString("EditorFontStyle",EditorFontStyle$)
      
    PreferenceComment("")
    PreferenceGroup("StructureViewer")
      WritePreferenceLong("X"      , StructureViewerX)
      WritePreferenceLong("Y"      , StructureViewerY)
      WritePreferenceLong("Width"  , StructureViewerWidth)
      WritePreferenceLong("Height" , StructureViewerHeight)
      WritePreferenceLong("IncType", StructureViewerIncludeType)

   PreferenceComment("")
   PreferenceGroup("ProcedureBrowser")
      WritePreferenceLong  ("Type"         , ProcedureBrowserType)
      WritePreferenceLong  ("Side"         , ProcedureBrowserSide) ; Side: 0 = Right, 1 = Left
      WritePreferenceString("Font"         , ProcedureBrowserFont)
      WritePreferenceLong  ("FontSize"     , ProcedureBrowserFontHeight)
      WritePreferenceString("FontStyle"    , ProcedureBrowserFontStyle$)
      WritePreferenceLong  ("BackColor"    , ProcedureBrowserBackColor)
      WritePreferenceLong  ("FrontColor"   , ProcedureBrowserFrontColor)
      WritePreferenceLong  ("Width"        , ProcedureBrowserWidth)
      WritePreferenceLong  ("Sort"         , ProcedureBrowserSort)
      WritePreferenceLong  ("GroupMarker"  , ProcedureBrowserGroupMarker)

   PreferenceComment("")
   PreferenceGroup("PickColorPrefs")
      ; WritePreferenceLong  ("StayOnTop"     , PickColor_StayOnTop)
      WritePreferenceLong  ("CloseAfterDone", PickColor_CloseAfterDone)

   PreferenceComment("")
   PreferenceGroup("RecentFiles")
      RecentFilesCount = CountList( RecentFiles() )
      WritePreferenceLong  ("Count", RecentFilesCount)
      If RecentFilesCount
         ResetList( RecentFiles() )
         For k = 1 To RecentFilesCount
           NextElement( RecentFiles() )
           WritePreferenceString("RecentFile_"+Str(k), RecentFiles() )
         Next
      EndIf

   PreferenceComment("")
   PreferenceGroup("OpenedFiles")
      
      OpenedFilesCount = 0
      
      CurrentIndex = ListIndex(FileList()) ; Save the current index, as it will changed and need to be restored
      
      ForEach FileList()
        If FileList()\FileName$ ; Test needed because a '<New>' file doesn't have a name and can't be reopened
          OpenedFilesCount + 1
          WritePreferenceString("OpenedFile_"+Str(OpenedFilesCount), FileList()\FileName$)
        EndIf
      Next
      
      SelectElement(FileList(), CurrentIndex) ; Restore the current list element
      
      WritePreferenceLong("Count", OpenedFilesCount)

      
   PreferenceComment("")
   PreferenceGroup("GrepOutput")
      WritePreferenceLong("X"      , GrepOutputX)
      WritePreferenceLong("Y"      , GrepOutputY)
      WritePreferenceLong("Width"  , GrepOutputWidth)
      WritePreferenceLong("Height" , GrepOutputHeight)
      
    ClosePreferences()
  EndIf
  
EndProcedure


Procedure ColorManager()

  Select GetGadgetState(#GADGET_Preference_ColorList)
    Case 0 : *Color = @BackgroundColor  
    Case 1 : *Color = @BasicKeywordColor
    Case 2 : *Color = @BasicKeywordColor_ProgramFlow
    Case 3 : *Color = @CommentColor    
    Case 4 : *Color = @ConstantColor   
    Case 5 : *Color = @StringColor     
    Case 6 : *Color = @StringColor2
    Case 7 : *Color = @PureKeywordColor
    Case 8 : *Color = @NormalTextColor 
    Case 9 : *Color = @ASMKeywordColor 
    Case 10: *Color = @OperatorColor
    Case 11: *Color = @SeparatorColor
    Case 12: *Color = @StructureColor
    Case 13: *Color = @NumberColor
    Case 14: *Color = @PointerColor
    Case 15: *Color = @LabelColor
    Case 16: *Color = @LineNumberColor
    Case 17: *Color = @LineNumberBackColor
  EndSelect
  
  SelectedColor = ColorRequester(PeekL(*Color))
  If SelectedColor > -1
    ColorChanged = 1
    PokeL(*Color, SelectedColor)  ; Update the color to the right variable
    
    UpdateTextHighlightning(1, 0, 0)

    If *LineNumbers
      SendMessage_(*LineNumbers,#EM_SETBKGNDCOLOR,0,LineNumberBackColor)
    EndIf
    OldLineNumberStart = -1 ; force update
    UpdateLineNumbering()

    UseWindow(#WINDOW_Preference)
    ActivateWindow()
  EndIf
EndProcedure


Procedure SelectFont()

  If SelectedFontName
   FontName.s = SelectedFontName
   FontSize   = SelectedFontSize
  Else
   FontName = EditorFontName
   FontSize = EditorFontSize
  EndIf
  
  If FontRequester(FontName, FontSize, 0)
    SelectedFontName = SelectedFontName()
    SelectedFontSize = SelectedFontSize()
    EditorFontStyle  = SelectedFontStyle()

    EditorFontStyle$ = ""
    If EditorFontStyle & #PB_Font_Bold
      EditorFontStyle$ = "Bold"
    EndIf
    If EditorFontStyle & #PB_Font_Italic
      If EditorFontStyle$
        EditorFontStyle$ + ",Italic"
      Else
        EditorFontStyle$ = "Italic"
      EndIf
    EndIf
    If EditorFontStyle$ = ""
      EditorFontStyle$ = "None"
    EndIf
    Result = 1
  EndIf

  ProcedureReturn Result;
EndProcedure


Procedure OpenPreferenceWindow()

  WINDOW_Preference_Width  = 380
  WINDOW_Preference_Height = 483

  If OpenWindow(#WINDOW_Preference, 0, 0, WINDOW_Preference_Width, WINDOW_Preference_Height, #PB_Window_SystemMenu | #PB_Window_WindowCentered | #PB_Window_Invisible, Langage(47), WindowID(#WINDOW_Main))

    If CreateGadgetList(WindowID())
      PanelGadget(#GADGET_Preference_MainPanel,6,6,WINDOW_Preference_Width-12,WINDOW_Preference_Height-42)
      AddGadgetItem(#GADGET_Preference_MainPanel,-1, Langage(85)) ; "General"
      Top = 10
          TextGadget  (#PB_Any, 10, Top+2, 300, 20, Langage(48)) ; "Source directory"
          StringGadget(#GADGET_Preference_Source      , 100, Top, WINDOW_Preference_Width-160, 20, SourceDirectory)
          ButtonGadget(#GADGET_Preference_SelectSource, WINDOW_Preference_Width-55, Top,  30, 20, "...") : Top+27

          TextGadget  (0, 10, Top+2, 300, 20, Langage(186)+" :") ; "Visual Designer"
          StringGadget(#GADGET_Preference_VisualDesigner, 100, Top, WINDOW_Preference_Width-160, 20,VisualDesigner$)
          ButtonGadget(#GADGET_Preference_SelectVD, WINDOW_Preference_Width-55, Top,  30, 20, "...") : Top+27
          
          TextGadget    (#PB_Any, 10, Top+3, 300, 20, Langage(49)) ; "Language"
          ComboBoxGadget(#GADGET_Preference_Language, 100, Top,  WINDOW_Preference_Width-125, 200) : Top+30
          
          CheckBoxGadget(#GADGET_Preference_EnableColoring,  10, Top, 90, 20, Langage(50)) ; Syntax coloring
          ComboBoxGadget(#GADGET_Preference_ColorList     , 100, Top, WINDOW_Preference_Width-160, 200);
          ButtonGadget  (#GADGET_Preference_ColorChooser  , WINDOW_Preference_Width-55, Top, 30, 22, "...") : Top+30
          
          TextGadget(#PB_Any, 10, Top+3, 300, 20, Langage(62)); ; Editor Font
          ButtonGadget  (#GADGET_Preference_Font, 100, Top, WINDOW_Preference_Width-125, 22, Langage(64)) : Top+30

          CheckBoxGadget(#GADGET_Preference_AutoReload    , 10, Top, 320, 20, Langage(51)) : Top+25;  ; "Auto-reload last project at start"
          CheckBoxGadget(#GADGET_Preference_AutoSave      , 10, Top, 320, 20, Langage(61)) : Top+25;  ; "Memorize window position at end"
          CheckBoxGadget(#GADGET_Preference_MemorizeWindow, 10, Top, 320, 20, Langage(52)) : Top+25;  ; "Memorize window position at end"
          CheckBoxGadget(#GADGET_Preference_RunOnce       , 10, Top, 320, 20, Langage(83)) : Top+25;  ; "Run one instance only"
          CheckBoxGadget(#GADGET_Preference_MemorizeCursor, 10, Top, 320, 20, Langage(155)): Top+25;  ; "Memorize Cursorposition"
          CheckBoxGadget(#GADGET_Preference_RealTimeSyntaxHighlighting, 10, Top, 320, 20, Langage(163)): Top+25;  ; "RealTime Syntax Highlighting"
          CheckBoxGadget(#GADGET_Preference_ShowToolbar   , 10, Top, 320, 20, Langage(182)): Top+25   ; "Show Toolbar"
          CheckBoxGadget(#GADGET_Preference_ShowLineNumbers,10, Top, 320, 20, Langage(183)): Top+25   ; "Display Line Numbers"
          
          CheckBoxGadget(#GADGET_Preference_CustomScroll,   10, Top, 150, 20, "Custom mousescroll?")
          TextGadget(#GADGET_Preference_ScrollLinesValue,   160,Top, 30,  20, Str(CustomScrollLines),#PB_Text_Right|#PB_Text_Border)
          SpinGadget(#GADGET_Preference_ScrollLinesUpDown,  191,Top,  9,  20, 1, 30) : Top + 30

          TextGadget(#PB_Any, 10, Top+3, 89, 20, Langage(84)) ; "TAB length:"
          TextGadget(#GADGET_Preference_TabLengthText     ,100, Top,  30, 20, Str(TabLength),#PB_Text_Right|#PB_Text_Border)
          SpinGadget(#GADGET_Preference_TabLengthUpDown   ,131, Top,   9, 20, 1, 30)

          AddGadgetItem(#GADGET_Preference_Language, -1, "English")
          AddGadgetItem(#GADGET_Preference_Language, -1, "Deutsch")
          AddGadgetItem(#GADGET_Preference_Language, -1, "Dutch")
          AddGadgetItem(#GADGET_Preference_Language, -1, "Francais")
          AddGadgetItem(#GADGET_Preference_Language, -1, "Greek")
          AddGadgetItem(#GADGET_Preference_Language, -1, "Italian")
          AddGadgetItem(#GADGET_Preference_Language, -1, "Japanese")
          AddGadgetItem(#GADGET_Preference_Language, -1, "Portuguese")
          AddGadgetItem(#GADGET_Preference_Language, -1, "Spanish")
          SetGadgetText(#GADGET_Preference_Language, CurrentLanguage)
          
          AddGadgetItem(#GADGET_Preference_ColorList, -1, Langage(56)) ; "Background"
          AddGadgetItem(#GADGET_Preference_ColorList, -1, Langage(57)) ; "Basic Keyword"
          AddGadgetItem(#GADGET_Preference_ColorList, -1, Langage(57)+": Program Flow (If..Endif,While..Wend)") ; "Basic Keyword: Program Flow (If..Endif,While..Wend)"
          AddGadgetItem(#GADGET_Preference_ColorList, -1, Langage(58)) ; "Comment"
          AddGadgetItem(#GADGET_Preference_ColorList, -1, Langage(59)) ; "Constant"
          AddGadgetItem(#GADGET_Preference_ColorList, -1, Langage(60)) ; "String"
          AddGadgetItem(#GADGET_Preference_ColorList, -1, Langage(165)); "String$ with extension '$'"
          AddGadgetItem(#GADGET_Preference_ColorList, -1, Langage(63)) ; "Commands/Procedures"
          AddGadgetItem(#GADGET_Preference_ColorList, -1, Langage(65)) ; "Normal Text"
          AddGadgetItem(#GADGET_Preference_ColorList, -1, Langage(152)); "ASM Keyword"
          AddGadgetItem(#GADGET_Preference_ColorList, -1, Langage(157)); "Operators:   = + - / & | ! ~ < >"
          AddGadgetItem(#GADGET_Preference_ColorList, -1, Langage(158)); "Separators:  ( ) [ ] . , : \"
          AddGadgetItem(#GADGET_Preference_ColorList, -1, Langage(159)); "Structures"
          AddGadgetItem(#GADGET_Preference_ColorList, -1, Langage(160)); "Numbers"
          AddGadgetItem(#GADGET_Preference_ColorList, -1, Langage(161)); "Pointer"
          AddGadgetItem(#GADGET_Preference_ColorList, -1, Langage(162)); "Labels"
          AddGadgetItem(#GADGET_Preference_ColorList, -1, Langage(184)); "LineNumbers: Color"
          AddGadgetItem(#GADGET_Preference_ColorList, -1, Langage(185)); "LineNumbers: Background"
          SetGadgetState(#GADGET_Preference_ColorList, 1) ; "Background"
          
          SetGadgetState(#GADGET_Preference_AutoReload     , AutoReload)
          SetGadgetState(#GADGET_Preference_AutoSave       , AutoSave)
          SetGadgetState(#GADGET_Preference_MemorizeWindow , MemorizeWindow)
          SetGadgetState(#GADGET_Preference_RunOnce        , Editor_RunOnce)
          SetGadgetState(#GADGET_Preference_MemorizeCursor , MemorizeCursor)
          SetGadgetState(#GADGET_Preference_RealTimeSyntaxHighlighting,RealTimeSyntaxHighlighting)
          SetGadgetState(#GADGET_Preference_ShowToolbar    , ShowMainToolbar)
          SetGadgetState(#GADGET_Preference_ShowLineNumbers, DisplayLineNumbers)
          SetGadgetState(#GADGET_Preference_TabLengthUpDown, TabLength)
          
          SetGadgetState(#GADGET_Preference_CustomScroll    , UseCustomScroll)
          SetGadgetState(#GADGET_Preference_ScrollLinesUpDown, CustomScrollLines)
          DisableGadget(#GADGET_Preference_ScrollLinesValue , 1-UseCustomScroll)
          DisableGadget(#GADGET_Preference_ScrollLinesUpDown, 1-UseCustomScroll)
          
          SetGadgetState(#GADGET_Preference_EnableColoring, EnableColoring)
          DisableGadget (#GADGET_Preference_ColorList     , 1-EnableColoring)
          DisableGadget (#GADGET_Preference_ColorChooser  , 1-EnableColoring)
          
      AddGadgetItem(#GADGET_Preference_MainPanel,-1, Langage(86)) ; "Procedure Browser"
      Top = 10
          OptionGadget(#GADGET_Preference_ProcedureBrowserCombobox,     10, Top, 300, 20, Langage(87)):  Top + 25  ; "ComboBox in toolbar"
          OptionGadget(#GADGET_Preference_ProcedureBrowserListView,     10, Top, 135, 20, Langage(88))  ; "ListView on side :"
          ComboBoxGadget(#GADGET_Preference_ProcedureBrowserListSide,   150, Top, WINDOW_Preference_Width-175,60) : Top +28
             AddGadgetItem(#GADGET_Preference_ProcedureBrowserListSide,  -1, Langage(89))  ; "Right"
             AddGadgetItem(#GADGET_Preference_ProcedureBrowserListSide,  -1, Langage(90))  ; "Left"
             SetGadgetState(#GADGET_Preference_ProcedureBrowserListSide, ProcedureBrowserSide)

          TextGadget(#PB_Any, 30,Top+3, 119,20, Langage(115)) ; "Browser colors :"

          ComboBoxGadget(#GADGET_Preference_ProcedureBrowserColorList     , 150,  Top, WINDOW_Preference_Width-210, 60)
             AddGadgetItem(#GADGET_Preference_ProcedureBrowserColorList, -1, Langage(56)) ; "Background"
             AddGadgetItem(#GADGET_Preference_ProcedureBrowserColorList, -1, Langage(63)) ; "Commands/Procedures"
             SetGadgetState(#GADGET_Preference_ProcedureBrowserColorList, 0)
          ButtonGadget  (#GADGET_Preference_ProcedureBrowserColorChooser  , WINDOW_Preference_Width-55, Top, 30, 22, "...") : Top+28

          TextGadget(#PB_Any, 30, Top+3, 119, 20, Langage(116)) ; "Browser font :"
          ButtonGadget  (#GADGET_Preference_ProcedureBrowserFont       , 150, Top, WINDOW_Preference_Width-175, 22, Langage(91)): Top+30  ; "Choose a Font"
          CheckBoxGadget(#GADGET_Preference_ProcedureBrowserSort       ,  10, Top, WINDOW_Preference_Width-30 , 20, Langage(92)): Top+25  ; "Sort Procedures/Comments in alphabetical order"
          CheckBoxGadget(#GADGET_Preference_ProcedureBrowserGroupMarker,  10, Top, WINDOW_Preference_Width-30 , 20, Langage(93)): Top+30  ; "Group markers together"
          
          ;Frame3DGadget(0,3,0,WINDOW_Preference_Width-10,160,"Procedure Browser",0)
          ; ProcedureBrowser Gadget States
          ; - Option Gadgets
          SetGadgetState(#GADGET_Preference_ProcedureBrowserCombobox,    1-ProcedureBrowserType)
          SetGadgetState(#GADGET_Preference_ProcedureBrowserListView,    0+ProcedureBrowserType)
          ; - Sorting
          SetGadgetState(#GADGET_Preference_ProcedureBrowserSort,        0+ProcedureBrowserSort)
          ; - Marker
          If ProcedureBrowserSort = 0
             SetGadgetState(#GADGET_Preference_ProcedureBrowserGroupMarker, 0+ProcedureBrowserGroupMarker)
          Else
             SetGadgetState(#GADGET_Preference_ProcedureBrowserGroupMarker, 1)
             DisableGadget(#GADGET_Preference_ProcedureBrowserGroupMarker , 1)
          EndIf
          ; - Enable or Disable Option Gadgets for ListView
          DisableGadget(#GADGET_Preference_ProcedureBrowserListSide,     1-ProcedureBrowserType)
          DisableGadget(#GADGET_Preference_ProcedureBrowserColorList,    1-ProcedureBrowserType)
          DisableGadget(#GADGET_Preference_ProcedureBrowserColorChooser, 1-ProcedureBrowserType)
          DisableGadget(#GADGET_Preference_ProcedureBrowserFont,         1-ProcedureBrowserType)

          Top = 110
          
      CloseGadgetList()

      ButtonGadget (#GADGET_Preference_Cancel, WINDOW_Preference_Width/2+4, WINDOW_Preference_Height-30, WINDOW_Preference_Width/2-10 , 25, Langage(53)); ; "Cancel"
      ; ButtonGadget (#GADGET_Preference_Use   , WINDOW_Preference_Width/3    , WINDOW_Preference_Height-30, WINDOW_Preference_Width/3-4 , 25, Langage(54)); ; "Use"
      ButtonGadget (#GADGET_Preference_Save  ,           6                  , WINDOW_Preference_Height-30, WINDOW_Preference_Width/2-10, 25, Langage(55)); ; "Save"
    EndIf
  
    HideWindow(#WINDOW_Preference, 0)
  
    SelectedFontName = ""
    
    ProcedureBrowserTempType          = ProcedureBrowserType
    ProcedureBrowserTempSide          = ProcedureBrowserSide
    ProcedureBrowserTempBackColor     = ProcedureBrowserBackColor
    ProcedureBrowserTempFrontColor    = ProcedureBrowserFrontColor
    ProcedureBrowserTempFont          = ProcedureBrowserFont
    ProcedureBrowserTempFontHeight    = ProcedureBrowserFontHeight
    ProcedureBrowserTempSort          = ProcedureBrowserSort
    ProcedureBrowserTempGroupMarker   = ProcedureBrowserGroupMarker
    
    Editor_RunOnceTemp                = Editor_RunOnce
    TabLengthTemp                     = TabLength
    
    ColorChanged                      = 0

    Repeat
      Select WaitWindowEvent()
     
        Case #PB_EventCloseWindow
          Quit = 1
       
        Case #PB_EventGadget
       
          Select EventGadgetID()
         
            Case #GADGET_Preference_Save
              UsePreferences()
              SavePreferences()
              Quit = 1
              
            ;Case #GADGET_Preference_Use
            ;  UsePreferences()
            ;  Quit = 1
              
            Case #GADGET_Preference_Cancel
              CancelPreferences()
              Quit = 1
              
            Case #GADGET_Preference_UseIcon
              State = GetGadgetState(#GADGET_Preference_UseIcon)
              DisableGadget(ST_Preference_IconName  , 1-State)
              DisableGadget(BT_Preference_SelectIcon, 1-State)

            Case #GADGET_Preference_SelectSource:
              Path$ = PathRequester("", GetGadgetText(#GADGET_Preference_Source))
              If Path$
                SetGadgetText(#GADGET_Preference_Source, Path$);
              EndIf

            Case #GADGET_Preference_VisualDesigner
              If EventType()=#PB_EventType_Change
                VisualDesigner$ = GetGadgetText(#GADGET_Preference_VisualDesigner)
              EndIf

            Case #GADGET_Preference_SelectVD
              Path$ = OpenFileRequester("", GetGadgetText(#GADGET_Preference_VisualDesigner),"Visual Designer (.exe)|*.exe",0)
              If Path$
                SetGadgetText(#GADGET_Preference_VisualDesigner, Path$)
                VisualDesigner$=Path$
              EndIf

            Case #GADGET_Preference_Font

              If SelectFont()
                SetEditorFont(SelectedFontName, SelectedFontSize);
                UpdateTextHighlightning(GetGadgetState(#GADGET_Preference_EnableColoring), 0, 0);

                ; Change the font for all opened files
                ; #WM_SetFont fires a notification message to the parent window
                ; so we need to inhibate the process with 'NoRichEditChanges'
                ;
                *CurrentRichEditGadget = *RichEditGadget
                NoRichEditChanges = #True
                
                Position = @FileList()
                ForEach FileList()
                  If FileList()\RichEdit <> *CurrentRichEditGadget  ; Already refreshed, don't do 2 time the same thing
                    *RichEditGadget = FileList()\RichEdit
                    SendMessage_(*RichEditGadget, #WM_SETFONT, *LineNumberFontHandle, 0)  ; The font has been loaded in the SetEditorFont() routine, above
                    UpdateTextHighlightning(GetGadgetState(#GADGET_Preference_EnableColoring), 0, 0);
                  EndIf
                Next  
                ChangeCurrentElement(FileList(), Position)
                
                NoRichEditChanges = #False
                *RichEditGadget = *CurrentRichEditGadget
              EndIf
              
            Case #GADGET_Preference_EnableColoring

              State = GetGadgetState(#GADGET_Preference_EnableColoring)
              DisableGadget(#GADGET_Preference_ColorList,    1-State)
              DisableGadget(#GADGET_Preference_ColorChooser, 1-State)
              UpdateTextHighlightning(State, 0, 0)
                
              UseWindow(#WINDOW_Preference)
              ActivateWindow()
 
             Case #GADGET_Preference_ColorChooser
               ColorManager()
             
             Case #GADGET_Preference_ProcedureBrowserComboBox
                  ProcedureBrowserTempType = 0
                  SetGadgetState(#GADGET_Preference_ProcedureBrowserCombobox,     1-ProcedureBrowserTempType)
                  SetGadgetState(#GADGET_Preference_ProcedureBrowserListView,     0+ProcedureBrowserTempType)
                  DisableGadget (#GADGET_Preference_ProcedureBrowserListSide,     1)
                  DisableGadget (#GADGET_Preference_ProcedureBrowserColorList,    1)
                  DisableGadget (#GADGET_Preference_ProcedureBrowserColorChooser, 1)
                  DisableGadget (#GADGET_Preference_ProcedureBrowserFont,         1)

             Case #GADGET_Preference_ProcedureBrowserListView
                  ProcedureBrowserTempType = 1
                  SetGadgetState(#GADGET_Preference_ProcedureBrowserCombobox,     1-ProcedureBrowserTempType)
                  SetGadgetState(#GADGET_Preference_ProcedureBrowserListView,     0+ProcedureBrowserTempType)
                  DisableGadget (#GADGET_Preference_ProcedureBrowserListSide,     0)
                  DisableGadget (#GADGET_Preference_ProcedureBrowserColorList,    0)
                  DisableGadget (#GADGET_Preference_ProcedureBrowserColorChooser, 0)
                  DisableGadget (#GADGET_Preference_ProcedureBrowserFont,         0)
                  
             Case #GADGET_Preference_ProcedureBrowserListSide
                  ProcedureBrowserTempSide = GetGadgetState(#GADGET_Preference_ProcedureBrowserListSide)
             
             Case #GADGET_Preference_ProcedureBrowserColorChooser
                  ProcedureBrowserColor = ColorRequester()
                  If ProcedureBrowserColor > -1
                     Select GetGadgetState(#GADGET_Preference_ProcedureBrowserColorList)
                        Case 0: ProcedureBrowserTempBackColor  = ProcedureBrowserColor
                        Case 1: ProcedureBrowserTempFrontColor = ProcedureBrowserColor
                     EndSelect
                  EndIf

             Case #GADGET_Preference_ProcedureBrowserFont
                  If FontRequester(ProcedureBrowserTempFont, ProcedureBrowserTempFontHeight, 0)
                     ProcedureBrowserTempFont       = SelectedFontName()
                     ProcedureBrowserTempFontHeight = SelectedFontSize()
                     ProcedureBrowserFontFlag       = SelectedFontStyle()

                     ProcedureBrowserFontStyle$ = ""
                     If ProcedureBrowserFontFlag & #PB_Font_Bold
                       ProcedureBrowserFontStyle$ = "Bold"
                     EndIf
                     If ProcedureBrowserFontFlag & #PB_Font_Italic
                       If ProcedureBrowserFontStyle$
                         ProcedureBrowserFontStyle$ + ",Italic"
                       Else
                         ProcedureBrowserFontStyle$ = "Italic"
                       EndIf
                     EndIf
                     If ProcedureBrowserFontStyle$ = ""
                       ProcedureBrowserFontStyle$ = "None"
                     EndIf
                  EndIf
                  
             Case #GADGET_Preference_ProcedureBrowserSort
                  ProcedureBrowserTempSort = GetGadgetState(#GADGET_Preference_ProcedureBrowserSort)
                  If ProcedureBrowserTempSort = 1
                    SetGadgetState(#GADGET_Preference_ProcedureBrowserGroupMarker, 1)
                    DisableGadget(#GADGET_Preference_ProcedureBrowserGroupMarker , 1)
                    ProcedureBrowserTempGroupMarker = 1
                  Else
                    DisableGadget(#GADGET_Preference_ProcedureBrowserGroupMarker , 0)
                  EndIf

             Case #GADGET_Preference_ProcedureBrowserGroupMarker
                  ProcedureBrowserTempGroupMarker = GetGadgetState(#GADGET_Preference_ProcedureBrowserGroupMarker)
                  
             Case #GADGET_Preference_RunOnce
                  Editor_RunOnceTemp = GetGadgetState(#GADGET_Preference_RunOnce)
                  
             Case #GADGET_Preference_TabLengthUpDown
                  TabLengthTemp = GetGadgetState(#GADGET_Preference_TabLengthUpDown)
                  SetGadgetText(#GADGET_Preference_TabLengthText, Str(TabLengthTemp))
             
             Case #GADGET_Preference_RealTimeSyntaxHighlighting
                  RealTimeSyntaxHighlighting = GetGadgetState(#GADGET_Preference_RealTimeSyntaxHighlighting)

             Case #GADGET_Preference_ShowLineNumbers
                  DisplayLineNumbers = GetGadgetState(#GADGET_Preference_ShowLineNumbers)
                  OldLineNumberStart = -1 ; force update
                  UpdateLineNumbering()

              Case #GADGET_Preference_CustomScroll
                  State = GetGadgetState(#GADGET_Preference_CustomScroll)
                  DisableGadget(#GADGET_Preference_ScrollLinesValue, 1 - State)
                  DisableGadget(#GADGET_Preference_ScrollLinesUpDown, 1 - State)
                  
              Case #GADGET_Preference_ScrollLinesUpDown
                  SetGadgetText(#GADGET_Preference_ScrollLinesValue, Str(GetGadgetState(#GADGET_Preference_ScrollLinesUpDown)))

          EndSelect
           
      EndSelect
     
    Until Quit = 1
  EndIf
  
  CloseWindow(#WINDOW_Preference)
  UseWindow  (#WINDOW_Main)
EndProcedure  
; ExecutableFormat=
; UseMainFile=PureBasic IDE.pb
; EOF