;
; < -------------------------------- >
;   PureBasic IDE - ProcedureBrowser 
; < -------------------------------- >
;
; This program is free software; you can redistribute it and/or modify it under
; the terms of the GNU General Public License as published by the Free Software
; Foundation; either version 2 of the License, or (at your option) any later
; version. See the License.txt file for more details.
; 
; (c) 2002 Fantaisie Software
;

Structure myProcBrowser
   Name.s
   Line.l
   ListViewIndex.l
EndStructure

NewList Procedure_Browser_NewList.myProcBrowser()
NewList Procedure_Browser_OldList.myProcBrowser()


Procedure OpenProcedureBrowser()

  FreeGadget(#GADGET_ProcedureList)
  FreeGadget(#GADGET_ProcedureBrowser)
 
  If ProcedureBrowserSort
    ComboBoxStyle         = #CBS_SORT
    ProcedureBrowserStyle = #LBS_SORT | #LBS_NOINTEGRALHEIGHT | #LBS_HASSTRINGS
  Else
    ProcedureBrowserStyle = #LBS_NOINTEGRALHEIGHT | #LBS_HASSTRINGS
  EndIf

  UseGadgetList(*MainToolbar)
  *CX_ProcedureList = ComboBoxGadget(#GADGET_ProcedureList, 325, 1, 150, 200, ComboBoxStyle)

  UseGadgetList(*MainWindow)
  *ProcedureBrowser = ListViewGadget(#GADGET_ProcedureBrowser,800,800,400,400,ProcedureBrowserStyle)

  ; Set Font for Procedure Browser
  fontflag = 0
  If FindString(UCase(ProcedureBrowserFontStyle$),"BOLD",1)
    fontflag | #PB_Font_Bold
  EndIf
  If FindString(UCase(ProcedureBrowserFontStyle$),"ITALIC",1)
    fontflag | #PB_Font_Italic
  EndIf
  *ProcedureBrowserFontHandle = LoadFont(#FONT_ProcedureBrowser,ProcedureBrowserFont,ProcedureBrowserFontHeight,fontflag)
  SendMessage_(*ProcedureBrowser, #WM_SETFONT, *ProcedureBrowserFontHandle, 0)
  InvalidateRect_(*ProcedureBrowser,0,0)

  ; Hide ProcedureBrowser or Procedure ComboBox
  If ProcedureBrowserType
     HideGadget(#GADGET_ProcedureList, 1)
  Else
     HideGadget(#GADGET_ProcedureBrowser, 1)
  EndIf
EndProcedure


Procedure SetListViewIndex(line,a)
  ResetList( Procedure_Browser_OldList() )
  While NextElement(Procedure_Browser_OldList()) And found = 0
     If Procedure_Browser_OldList()\Line = line
        Procedure_Browser_OldList()\ListViewIndex = a
        found = 1
     EndIf
  Wend
EndProcedure


Procedure ProcedureBrowser_Update()

  ResetList( Procedure_Browser_NewList() )

  ; Clear Strings (fix, PB bug)
  ResetList( Procedure_Browser_OldList() )
  While NextElement( Procedure_Browser_OldList() )
    Procedure_Browser_OldList()\Name = ""
  Wend

  ClearList( Procedure_Browser_OldList() )

  While NextElement( Procedure_Browser_NewList() )
    If AddElement( Procedure_Browser_OldList() )
       Procedure_Browser_OldList()\Name = Procedure_Browser_NewList()\Name
       Procedure_Browser_OldList()\Line = Procedure_Browser_NewList()\Line
    EndIf
  Wend

  ; Stop redraw of ProcedureBrowser
  ;SendMessage_(*ProcedureBrowser, #WM_SETREDRAW, #FALSE, 0)

  ClearGadgetItemList(#GADGET_ProcedureBrowser)

  ; for ProcedureBrowser Scrollbar measurement
  hDC = GetDC_(*ProcedureBrowser)
  SelectObject_(hDC,*ProcedureBrowserFontHandle)
  ProcedureStringLength_Temp = 10

  SendMessage_(*ProcedureBrowser, $194, 10, 0) ; #LB_SETHORIZONTALEXTENT

  ResetList( Procedure_Browser_OldList() )

  While NextElement( Procedure_Browser_OldList() )

      If Left( Procedure_Browser_OldList()\Name, 2 ) = "> "
         isMarker = 1 : markernumber + 1
      Else
         isMarker = 0
      EndIf

      ; Add String to ProcedureBrowser - AddGadgetItem doesnt work with sorted ListView
      
      If     ProcedureBrowserSort = 0 And ProcedureBrowserGroupMarker = 1 And isMarker = 1
        AddStringIndex = SendMessage_ (*ProcedureBrowser, #LB_INSERTSTRING , markernumber-1, Procedure_Browser_OldList()\Name )
      Else
        AddStringIndex = SendMessage_ (*ProcedureBrowser, #LB_ADDSTRING    ,              0, Procedure_Browser_OldList()\Name )
      EndIf
      SendMessage_ (*ProcedureBrowser, #LB_SETITEMDATA, AddStringIndex, Procedure_Browser_OldList()\Line )
      
      ; for ProcedureBrowser Scrollbar measurement
      ProcedureTextSize.SIZE
      If GetTextExtentPoint32_(hDC, @Procedure_Browser_OldList()\Name, Len(Procedure_Browser_OldList()\Name),@ProcedureTextSize)
         If ProcedureTextSize\cx => ProcedureStringLength_Temp
            ProcedureStringLength_Temp = ProcedureTextSize\cx
         EndIf
      EndIf
  Wend

  For a = 0 To CountList(Procedure_Browser_OldList())-1
      line = SendMessage_(*ProcedureBrowser, #LB_GETITEMDATA, a, 0)
      SetListViewIndex(line,a)
  Next a

 ; for ProcedureBrowser Scrollbar measurement
 ;ReleaseDC_(*ProcedureBrowser,hDC)
 ; Allow redraw of ProcedureBrowser
 ;SendMessage_(*ProcedureBrowser, #WM_SETREDRAW, #TRUE, 0)
 ;InvalidateRect_(*ProcedureBrowser,0,0)

 ; Adjust ProcedureBrowser Scrollbar
 SendMessage_(*ProcedureBrowser, $194, ProcedureStringLength_Temp+5, 0) ; #LB_SETHORIZONTALEXTENT

EndProcedure


; Procedure.l ProcedureBrowser_FindString()
;  x = SendMessage_(*ProcedureBrowser, #LB_FINDSTRINGEXACT, -1, Procedure_Browser_OldList()\Name )
;  If x = #LB_ERR
;     Result = 1
;  Else
;     y = SendMessage_(*ProcedureBrowser, #LB_GETITEMDATA, x, 0 )
;     If y <> #LB_ERR And y = Procedure_Browser_OldList()\Line
;        SendMessage_(*ProcedureBrowser, #LB_SETITEMDATA, x, Procedure_Browser_NewList()\Line )
;        Procedure_Browser_OldList()\Line = Procedure_Browser_NewList()\Line
;        Result = 0
;     Else
;        Result = 1
;     EndIf
;  EndIf
; ProcedureReturn Result
; EndProcedure


Procedure ProcedureBrowser_CheckUpdate()

  ; If ListCount is different, something has changed --> update
  x = CountList( Procedure_Browser_NewList() )
  y = CountList( Procedure_Browser_OldList() )
  If ( x <> y )  Or  ProcedureBrowserMustUpdate > 0
     ProcedureBrowser_Update()
     ProcedureBrowserMustUpdate = 0
     Updated = 1
  EndIf

  If Updated = 0

     ResetList( Procedure_Browser_NewList() )
     ResetList( Procedure_Browser_OldList() )
         
     While NextElement( Procedure_Browser_OldList() ) And Updated = 0

         NextElement( Procedure_Browser_NewList() )

         ; When name has changed --> update
         If ( Procedure_Browser_OldList()\Name <> Procedure_Browser_NewList()\Name ) And Updated = 0
            ProcedureBrowser_Update()
            Updated = 1
         EndIf

         ; Check for changed line numbers (after return, backspace etc..)
         ; and update only the internal line number, because name hasnt changed
         If ( Procedure_Browser_OldList()\Line <> Procedure_Browser_NewList()\Line ) And Updated = 0
            SendMessage_ (*ProcedureBrowser, #LB_SETITEMDATA, Procedure_Browser_OldList()\ListViewIndex, Procedure_Browser_NewList()\Line )
            ;If ProcedureBrowser_FindString()
               ;ProcedureBrowser_Update()
               ;Updated = 1
            ;EndIf
         EndIf
         
     Wend

  EndIf

EndProcedure 


Procedure.l ProcedureBrowser_JumpOnCodeDoubleClick()
  Result = 0
  FunctionName$ = ""
  
  ; get the function name (note: GetCurrentWord() can't be used, because a '_' can be used)
  ;
  SendMessage_(*RichEditGadget, #EM_EXGETSEL      , 1         , Range.CHARRANGE)
  NeededLine    = SendMessage_(*RichEditGadget, #EM_EXLINEFROMCHAR, 0         , Range\cpMin)
  StartPosition = SendMessage_(*RichEditGadget, #EM_LINEINDEX     , NeededLine, 0)
  
  *Buffer = AllocateMemory(1000)
  If *Buffer
    PokeW(*Buffer, 900) ; First word contains the max number of char for the buffer...
    
    LineLength       = SendMessage_(*RichEditGadget, #EM_GETLINE  , NeededLine, *Buffer)
    *CurrentLine.Byte = *Buffer+Range\cpMin-StartPosition
    
    If Range\cpMin > StartPosition
      
      Repeat
        *CurrentLine-1
        CurrentChar = *CurrentLine\b & $FF
      Until (ValidCharacters(CurrentChar) = 0 And CurrentChar <> '_') Or Range\cpMin <= StartPosition
      
      *StartWord = *CurrentLine+1
    Else
      *StartWord = *CurrentLine
    EndIf
    
    Repeat
      *CurrentLine+1
      CurrentChar = *CurrentLine\b & $FF
    Until ValidCharacters(CurrentChar) = 0 And CurrentChar <> '_'
    
    ; check, if the name is really followed by a '('
    If *CurrentLine\b = '('
        
      *CurrentLine\b = 0 ; Zero terminate the string, to allow the PeekS()    
      FunctionName$ = UCase(PeekS(*StartWord))
    
    Else
      
      *CurrentLine\b = 0 ; Zero terminate the string, to allow the PeekS()    
      FunctionName$ = UCase(PeekS(*StartWord))      
        
      Repeat
        *CurrentLine + 1
      Until *CurrentLine\b <> ' ' And *CurrentLine\b <> 9
      
      If *CurrentLine\b <> '('
        FunctionName$ = ""
      EndIf
      
    EndIf
    
    FreeMemory(*Buffer)
  EndIf    
  
  ; jump to procedure (if existent in this file)
  ;
  If FunctionName$ <> ""
  
    ForEach Procedure_Browser_OldList()
    
      If UCase(Procedure_Browser_OldList()\Name) = FunctionName$
      
        ChangeActiveLine(Procedure_Browser_OldList()\Line, 0)
        SetFocus_(*RichEditGadget)
        Result = 1
        Break
      
      EndIf
    
    Next Procedure_Browser_OldList()
  
  EndIf

  ProcedureReturn Result
EndProcedure
; ExecutableFormat=
; EOF