;
; < --------------------------- >
;   PureBasic IDE - RecentFiles 
; < --------------------------- >
;
; This program is free software; you can redistribute it and/or modify it under
; the terms of the GNU General Public License as published by the Free Software
; Foundation; either version 2 of the License, or (at your option) any later
; version. See the License.txt file for more details.
; 
; (c) 2002 Fantaisie Software
;
      
XIncludeFile "Common.pb"

Procedure Menu_AddRecentFiles()

  Count = CountList(RecentFiles())
  If Count
     OpenSubMenu(Langage(111)) ; "Recent Files"
     
       ResetList(RecentFiles())
     
       For a = 1 To Count
          If NextElement( RecentFiles() )
             MenuItem(#MENU_RecentFilesStart+a-1, "&"+Str(a)+"  "+GetFilePart(RecentFiles()))
          EndIf
       Next a

     CloseSubMenu()  
  EndIf

EndProcedure


Procedure Menu_OpenRecentFile(MenuID)

  MenuID - #MENU_RecentFilesStart

  Count = CountList(RecentFiles())
  
  If Count
     If MenuID <= Count - 1
       SelectElement( RecentFiles(), MenuID )
       LoadSourceCodeReal(RecentFiles(), 0)     
     EndIf
  EndIf

EndProcedure


Procedure Menu_AddToRecentFiles(File$)

  If CountList(RecentFiles()) > 0
    FirstElement(RecentFiles())  
    If RecentFiles() = File$
      ProcedureReturn          ; No need to go further, it's already correct
    EndIf
  EndIf
  
  ResetList(RecentFiles())  ; Go BEFORE the first element
  AddElement(RecentFiles()) ; so this one will be always the first.
   
  RecentFiles() = File$
   
  FirstElement(RecentFiles())       ; Skip the first element, as this is the one just inserted
  While NextElement(RecentFiles()) ; And walk until the end of the list to detect the same name
    If RecentFiles() = File$
      DeleteElement(RecentFiles())  ; Remove the element. It could NOT have a next element with the same name.
    EndIf
  Wend

  Count = CountList(RecentFiles())
  If Count > #RECENTFILES_Maximum
    SelectElement( RecentFiles(), #RECENTFILES_Maximum)
    
    ;For a = 1 To Count - #RECENTFILES_Maximum
    While NextElement( RecentFiles() )
      DeleteElement(RecentFiles())
    Wend
    ;Next a
  EndIf

  CreateIDEMenu(1)
   
EndProcedure

; ExecutableFormat=
; Executable=C:\Documents and Settings\Administrator\Desktop\Edit\PureBasic NEW.exe
; EOF