;
; < ------------------------------- >
;   PureBasic IDE - OpenIncludeFile 
; < ------------------------------- >
;
; This program is free software; you can redistribute it and/or modify it under
; the terms of the GNU General Public License as published by the Free Software
; Foundation; either version 2 of the License, or (at your option) any later
; version. See the License.txt file for more details.
; 
; (c) 2002 Fantaisie Software
;

; by Danilo, 25.01.2003


Procedure.s RichEdit_OpenIncludeFile_SearchForIncludePath()
   B$ = Space(5000)
   SendMessage_(*RichEditGadget,#EM_EXGETSEL,0,range.CHARRANGE)
   Line = SendMessage_(*RichEditGadget,#EM_LINEFROMCHAR,range\cpMin,0)
   Repeat
     PokeW(@B$,5000)
     EndPosition = 0
     SendMessage_(*RichEditGadget,#EM_GETLINE,Line,@B$)
     Position = FindString(UCase(B$),"INCLUDEPATH",1)
     If Position And (FindString(B$,";",1) = 0 Or FindString(B$,";",1) > Position)
        Position = FindString(B$,Chr(34),Position)
        If Position
           EndPosition = FindString(B$,Chr(34),Position+1)
           If EndPosition And EndPosition > Position + 1
              B$ = Mid(B$,Position+1,EndPosition-Position-1)
              Line = 0
           EndIf
        EndIf
     EndIf
     Line - 1
   Until Line = -1
   If Line = -1 And EndPosition = 0
      ProcedureReturn ""
   Else
     If FindString(B$,":",1) Or Left(A$,2) = "\\"
       ProcedureReturn B$
     Else
       If Asc(B$) = '\'
         B$ = Right(B$,Len(B$)-1)
       EndIf
       ProcedureReturn GetPathPart(FileList()\FileName$)+B$
     EndIf
   EndIf
EndProcedure


Procedure RichEdit_OpenIncludeFile()
  A$ = Space(5000)
  PokeW(@A$,5000)
  SendMessage_(*RichEditGadget,#EM_EXGETSEL,0,range.CHARRANGE)
  If SendMessage_(*RichEditGadget,#EM_GETLINE,SendMessage_(*RichEditGadget,#EM_LINEFROMCHAR,range\cpMin,0),@A$)
     Position = FindString(UCase(A$),"INCLUDEFILE",1) 
     If Position
       A$ = Trim(Right(A$,Len(A$)-Position-10))
       Position = FindString(A$,Chr(34),1)
       If Position
         EndPosition = FindString(A$,Chr(34),Position+1)
         If EndPosition
            A$ = Mid(A$,Position+1,EndPosition-Position-1)
            Position = FindString(A$,":",1)
            If Position Or Left(A$,2) = "\\"
               ; Drive or network drive
              LoadSourceCodeReal(A$, 0)
            ;ElseIf Asc(A$) = '.'
            ;   ; relative path
            ;   LoadSourceCodeReal(GetPathPart(FileList()\FileName$)+A$)
              
            Else
                             
              IncludedPath$ = RichEdit_OpenIncludeFile_SearchForIncludePath()
              
              If IncludedPath$ = "" ; No IncludePath "xxxx" found, so consider the actual file as the good directory
                 
                CurrentFilePath$ = GetPathPart(FileList()\FileName$)
                If Asc(A$) = '\'
                  A$ = Right(A$,Len(A$)-1)
                EndIf
                FileName$ = CurrentFilePath$ + A$
               
              Else
               
                ; Special case: 
                ;
                ; IncludePath "C:\Test\Projects\"
                ; IncludeFile "\Test.pb"
                ;
                ; Should open: "C:\Test.pb"
                ;
               
                If Asc(A$) = '\'  ; Network \\ are tested above, don't worry
                
                  If Mid(IncludedPath$,2,1) = ":" ; Letter is specified
                  
                    FileName$ = Left(IncludedPath$, 2)+A$
                  
                  Else
                    FileName$ = A$
                  EndIf
                
                Else
                  If Right(IncludedPath$,1) <> "\"
                    IncludedPath$+"\"
                  EndIf
                 
                  FileName$ = IncludedPath$ + A$
                EndIf
               
              EndIf
                             
              If FileSize(FileName$) => 0 
                LoadSourceCodeReal(FileName$, 0)
              Else
                MessageRequester("Error","Cant find includefile: "+FileName$, #MB_ICONERROR)
              EndIf
            EndIf
         EndIf
       EndIf
     EndIf
  EndIf
EndProcedure

; Test cases

; IncludePath "..\Test\Projects\"
; IncludeFile "arrayspeed.pb"

; IncludePath "C:\Test\Projects\"
; IncludeFile "\arrayspeed.pb"

; IncludePath "Includes\"
; IncludeFile "arrayspeed.pb"


; ExecutableFormat=Windows
; DisableDebugger
; EOF